#if 1

/******************************************************************************
 *
 *	cheat.c
 *	by Ian Patterson [ianpatt@pacbell.net]
 *	
 *	The cheat engine for MAME. Allows you to search for locations in memory
 *	where gameplay-related values are stored, and change them. In other words,
 *	it lets you cheat.
 *	
 *	TODO:
 *		- finish UI
 *		- add multiple cheat searches
 *		- add conflict checking
 *	
 *****************************************************************************/

/******	Cheat File Specification **********************************************

Type Field:

MSB							   LSB
33222222 22221111 11111100 00000000
10987654 32109876 54321098 76543210

									[ type ]
-------- -------- -------- -------x		one-shot cheat
-------- -------- -------- -----xx-		type
											00 =	normal/delay
											01 =	wait for modification
											10 =	ignore if decrementing
											11 =	watch
-------- -------- -------- ---xx---		operation (combined	with operation
										extend bit)
											[extend	= 0]
												00 =	write with mask
												01 =	add/subtract
												10 =	force range
												11 =	set/clear bits (for
														relative address mode)
											[extend	= 1]
												00 =	unused
												01 =	unused
												10 =	unused
												11 =	nothing
-------- -------- -------- xxx-----		parameter
											type ==	00	delay in seconds
														between	operations
											type ==	01	delay after
														modification before
														operation in seconds
											type ==	10	decrement ignore value
											type ==	11	number of bytes	to
														watch
									[ user-selected	value ]
-------- -------- -------x --------		enable
-------- -------- ------x- --------		minimum	displayed value
											0 =	0
											1 =	1
-------- -------- -----x-- --------		minimum	value
											0 =	0
											1 =	1
-------- -------- ----x--- --------		BCD
									[ prefill ]
-------- -------- --xx---- --------		value/enable
											00 =	disable
											01 =	prefill	with 0xFF
											10 =	prefill	with 0x00
											11 =	prefill	with 0x01
									[ link / options ]
-------- -------x -------- --------		enable
-------- ------x- -------- --------		copy previous value
-------- -----x-- -------- --------		operation parameter
											operation == 001	add/subtract
												0 =	add
												1 =	subtract
											operation == 011	set/clear
												0 = set
												1 = clear
-------- ----x--- -------- --------		operation extend bit
-------- --xx---- -------- --------		bytes used
											00 =	1
											01 =	2
											10 =	3
											11 =	4
-------- -x------ -------- --------		endianness
											locations associated with a
											processor
												0 =		same endianness	as
														target processor
												1 =		different endianness
											generic	locations
												0 =		big	endian
												1 =		little endian
-------- x------- -------- --------		restore previous value on disable
									[ location / effective address ]
---xxxxx -------- -------- --------		parameter
											type ==	000	CPU	index
											type ==	001	region offset
														(REGION_xxx)
											type ==	010	CPU	index
											type ==	011	custom cheat type
												00000		comment
												00001		EEPROM
												00010		select
												...			others?
											type ==	100	address	size, CPU
												---00		8 bit
												---01		16 bit
												---10		24 bit
												---11		32 bit
												xxx--		cpu
xxx----- -------- -------- --------		type
											000	=	standard memory	write
											001	=	memory region
											010	=	write handler mapped memory
											011	=	custom
											100	=	relative address (CPU)
											101	=	unused
											110	=	unused
											111	=	unused

-------- -------- xx------ --------	currently unused

Conversion Table:

MSB								LSB
33222222 22221111 11111100 0000	0000
10987654 32109876 54321098 7654	3210
000xxxxx 00000000 00000000 0000	0000	000
000xxxxx 00000000 00000000 0000	0001	001
000xxxxx 00000000 00000000 0010	0000	002
000xxxxx 00000000 00000000 0100	0000	003
000xxxxx 00000000 00000000 1010	0000	004
000xxxxx 00000000 00000000 0010	0010	005
000xxxxx 00000000 00000000 0100	0010	006
000xxxxx 00000000 00000000 1010	0010	007
000xxxxx 00000000 00000000 0010	0100	008
000xxxxx 00000000 00000000 0100	0100	009
000xxxxx 00000000 00000000 0110	0100	010
000xxxxx 00000000 00000000 1000	0100	011
000xxxxx 00000000 00000000 0010	0011	015
000xxxxx 00000000 00000000 0100	0011	016
000xxxxx 00000000 00000000 1010	0011	017
000xxxxx 00000000 00000000 0000	0000	020	(mask used)
000xxxxx 00000000 00000000 0000	0001	021	(mask used)
000xxxxx 00000000 00000000 0010	0000	022	(mask used)
000xxxxx 00000000 00000000 0100	0000	023	(mask used)
000xxxxx 00000000 00000000 1010	0000	024	(mask used)
000xxxxx 00000000 00000000 0000	0000	040	(mask used)
000xxxxx 00000000 00000000 0000	0001	041	(mask used)
000xxxxx 00000000 00000000 0010	0000	042	(mask used)
000xxxxx 00000000 00000000 0100	0000	043	(mask used)
000xxxxx 00000000 00000000 1010	0000	044	(mask used)
000xxxxx 00000000 00000001 0000	0011	060
000xxxxx 00000000 00000011 0000	0011	061
000xxxxx 00000000 00000111 0000	0011	062
000xxxxx 00000000 00001001 0000	0011	063
000xxxxx 00000000 00001011 0000	0011	064
000xxxxx 00000000 00001111 0000	0011	065
000xxxxx 00000000 00000001 0000	0001	070
000xxxxx 00000000 00000011 0000	0001	071
000xxxxx 00000000 00000111 0000	0001	072
000xxxxx 00000000 00001001 0000	0001	073
000xxxxx 00000000 00001011 0000	0001	074
000xxxxx 00000000 00001111 0000	0001	075
001xxxxx 00000000 00000000 0000	0000	100
001xxxxx 00000000 00000000 0000	0001	101
001xxxxx 00000000 00000000 0000	0000	102
001xxxxx 00000000 00000000 0000	0001	103
010xxxxx 00000000 00000000 0000	0000	110
010xxxxx 00000000 00000000 0000	0001	111
010xxxxx 00000000 00000000 0000	0000	112
010xxxxx 00000000 00000000 0000	0001	113
00000000 00000001 00000000 0000	0000	5xx
000xxxxx 00000000 00000000 0010	0110	998
01100000 00000000 00000000 0000	0000	999

Cheat Format:

:[ drivername ]:[ type ]:[ address ]:[ data ]:[ extended data ]:[ name ]:[ description ]

drivername		string	maximum	8 chars
type			hex		32 bits
address			hex		32 bits
data			hex		32 bits
extended data	hex		32 bits
name			string	maximum	255	chars
description		string	maximum	255	chars

Extended Data Field:

[ force	range ]

0xAABB

AA = minimum value accepted
BB = maximum value accepted

[ add/subtract ]

The	field will store either	the	minimum	or maximum boundary	for	modification,
depending on the operation parameter.

[ write	with mask ]

The	field will store a mask	containing which bits are modified by the
operation. For normal operation, set the mask to 0xFFFFFFFF.
Example	code: data = (data & ~mask)	| (input & mask);

Copy Previous Value:

If this	field is true, the value for this cheat	is determined by taking	the
value read from	the	previous cheat and adding the value	stored in the data
field.

Relative Address:

The	extend data	field will store the the signed	offset to be applied to	the
address	read. Because of this, any operation using the extend data field may
have interesting results. Use the special set/clear bits operations instead of
a masked write.

Select Cheat Type: (01100010 -------0 -------- --------) 0x62000000

May	be used	only as	the	first cheat	of a linked	cheat. In the "Enable/Disable
Cheat" menu, instead of	simple listing On/Off or Set as	the	menu option, the
engine will	list the name fields of	each of	the	subcheats. If the current
selected subcheat is a one-shot	cheat, pressing	Enter will activate	the
currently subcheat.	If the subcheat	is an on/off cheat,	the	currently selected
subcheat (and only that	subcheat) will be activated.

Notes:

- if you want to have a	list of	many on/off	subcheats, include a "None"	option,
or there will be no	way	to disable the cheat
- the engine will display "Press Enter to Activate Cheat" if a one-shot	cheat
is selected

*******************************************************************************/

#include "driver.h"
#include "ui_text.h"
#include "machine/eeprom.h"
#include <ctype.h>

// do this until I can think of a better way to detect the Win32 version of MAME
#if defined(WIN32)
#define OSD_READKEY_KLUDGE	1
#else
#define OSD_READKEY_KLUDGE	0
#endif

/*
#define	InitCheat		New_InitCheat
#define	StopCheat		New_StopCheat
#define	cheat_menu		New_cheat_menu
#define	DoCheat			New_DoCheat
#define	DisplayWatches	New_DisplayWatches
#define he_did_cheat	New_he_did_cheat
#define cheatfile		New_cheatfile
*/

/**** Macros *****************************************************************/

//	easy bitfield extraction and setting
//	uses *_Shift, *_ShiftedMask, and *_Mask enums
#define EXTRACT_FIELD(data, name)				(((data) >> k##name##_Shift) & k##name##_ShiftedMask)
#define SET_FIELD(data, name, in)				(data = (data & ~(k##name##_ShiftedMask << k##name##_Shift)) | (((in) & k##name##_ShiftedMask) << k##name##_Shift))
#define TEST_FIELD(data, name)					((data) & k##name##_Mask)
#define SET_MASK_FIELD(data, name)				((data) |= k##name##_Mask)
#define CLEAR_MASK_FIELD(data, name)			((data) &= ~(k##name##_Mask))
#define TOGGLE_MASK_FIELD(data, name)			((data) ^= k##name##_Mask)

#define DEFINE_BITFIELD_ENUM(name, end, start)	k##name##_Shift = (int)(end), 											\
												k##name##_ShiftedMask = (int)(0xFFFFFFFF >> (32 - (start - end + 1))),	\
												k##name##_Mask = (int)(k##name##_ShiftedMask << k##name##_Shift)

#define CHEAT_FILENAME_MAX_LEN					255
#define MAX_LOADEDCHEATS						3000
#define MAX_SUBCHEATS							255

#define SWAP_BYTES								0

/**** Enums ******************************************************************/

enum
{
	DEFINE_BITFIELD_ENUM(OneShot,					0,	0),
	DEFINE_BITFIELD_ENUM(Type,						1,	2),
	DEFINE_BITFIELD_ENUM(Operation,					3,	4),
	DEFINE_BITFIELD_ENUM(TypeParameter,				5,	7),
	DEFINE_BITFIELD_ENUM(UserSelectEnable,			8,	8),
	DEFINE_BITFIELD_ENUM(UserSelectMinimumDisplay,	9,	9),
	DEFINE_BITFIELD_ENUM(UserSelectMinimum,			10,	10),
	DEFINE_BITFIELD_ENUM(UserSelectBCD,				11,	11),
	DEFINE_BITFIELD_ENUM(Prefill,					12,	13),
	DEFINE_BITFIELD_ENUM(LinkEnable,				16,	16),
	DEFINE_BITFIELD_ENUM(LinkCopyPreviousValue,		17,	17),
	DEFINE_BITFIELD_ENUM(OperationParameter,		18,	18),
	DEFINE_BITFIELD_ENUM(OperationExtend,			19,	19),
	DEFINE_BITFIELD_ENUM(BytesUsed,					20,	21),
	DEFINE_BITFIELD_ENUM(Endianness,				22,	22),
	DEFINE_BITFIELD_ENUM(RestorePreviousValue,		23, 24),
	DEFINE_BITFIELD_ENUM(LocationParameter,			24,	28),
	DEFINE_BITFIELD_ENUM(LocationType,				29,	31)
};

enum
{
	kType_NormalOrDelay = 0,
	kType_WaitForModification,
	kType_IgnoreIfDecrementing,
	kType_Watch
};

enum
{
	kOperation_WriteMask = 0,
	kOperation_AddSubtract,
	kOperation_ForceRange,
	kOperation_SetOrClearBits,
	// kOperation_Unused4,
	// kOperation_Unused5,
	// kOperation_Unused6,
	kOperation_None = 7
};

enum
{
	kPrefill_Disable = 0,
	kPrefill_UseFF,
	kPrefill_Use00,
	kPrefill_Use01
};

enum
{
	kLocation_Standard = 0,
	kLocation_MemoryRegion,
	kLocation_HandlerMemory,
	kLocation_Custom,
	kLocation_IndirectIndexed
};

enum
{
	kCustomLocation_Comment = 0,
	kCustomLocation_EEPROM,
	kCustomLocation_Select
};

enum
{
	// set for wait for modification or ignore if decrementing cheats when
	// the targeted value has changed
	// cleared after the operation is performed
	kActionFlag_WasModified =	1 << 0,
	
	// set for one shot cheats after the operation is performed
	kActionFlag_OperationDone =	1 << 1,
	
	// set if the extendData field is being used by something other than a mask value
	kActionFlag_IgnoreMask =	1 << 2,

	kActionFlag_StateMask =		kActionFlag_OperationDone,
	kActionFlag_InfoMask =		kActionFlag_WasModified |
								kActionFlag_IgnoreMask 
};

enum
{
	// true when the cheat is active
	kCheatFlag_Active =					1 << 0,
	
	// true if the cheat is entirely one shot
	kCheatFlag_OneShot =				1 << 1,
	
	// true if the cheat is entirely null (ex. a comment)
	kCheatFlag_Null =					1 << 2,
	
	// true if the cheat contains a user-select element
	kCheatFlag_UserSelect =				1 << 3,
	
	// true if the cheat is a select cheat
	kCheatFlag_Select =					1 << 4,

	// true if the activation key is being pressed
	kCheatFlag_ActivationKeyPressed =	1 << 5,

	// true if the cheat has been assigned an activation key
	kCheatFlag_HasActivationKey =		1 << 6,
	
	// masks
	kCheatFlag_StateMask =			kCheatFlag_Active,
	kCheatFlag_InfoMask =			kCheatFlag_OneShot |
									kCheatFlag_Null |
									kCheatFlag_UserSelect |
									kCheatFlag_Select |
									kCheatFlag_ActivationKeyPressed |
									kCheatFlag_HasActivationKey,
	kCheatFlag_PersistantMask =		kCheatFlag_HasActivationKey |
									kCheatFlag_ActivationKeyPressed
};

enum
{
	kWatchLabel_None = 0,
	kWatchLabel_Address,
	kWatchLabel_String,
	
	kWatchLabel_MaxPlusOne
};

enum
{
	kWatchDisplayType_Hex = 0,
	kWatchDisplayType_Decimal,
	kWatchDisplayType_Binary,
	
	kWatchDisplayType_MaxPlusOne
};

enum
{
	kVerticalKeyRepeatRate =		8,
	kHorizontalFastKeyRepeatRate =	5,
	kHorizontalSlowKeyRepeatRate =	8
};

enum
{
	// true if enabled for search
	kRegionFlag_Enabled =		1 << 0,
	
	// true if the memory region has no mapped memory
	// and uses a memory handler
	kRegionFlag_UsesHandler =	1 << 1
};

enum
{
	kRegionType_CPU = 0,
	kRegionType_Memory
};

enum
{
	kSearchSpeed_Fast = 0,		// RAM + some banks
	kSearchSpeed_Medium,		// RAM + BANKx
	kSearchSpeed_Slow,			// all memory areas except ROM, NOP, and custom handlers
	kSearchSpeed_VerySlow,		// all memory areas except ROM and NOP
	kSearchSpeed_AllMemory		// entire CPU address space
};

enum
{
	kSearchOperand_Current = 0,
	kSearchOperand_Previous,
	kSearchOperand_First,
	kSearchOperand_Value,

	kSearchOperand_Max = kSearchOperand_Value
};

enum
{
	kSearchSize_8Bit = 0,
	kSearchSize_16Bit,
	kSearchSize_32Bit,
	kSearchSize_1Bit,

	kSearchSize_Max = kSearchSize_1Bit
};

enum
{
	kSearchComparison_LessThan = 0,
	kSearchComparison_GreaterThan,
	kSearchComparison_EqualTo,
	kSearchComparison_LessThanOrEqualTo,
	kSearchComparison_GreaterThanOrEqualTo,
	kSearchComparison_NotEqual,

	kSearchComparison_Max = kSearchComparison_NotEqual
};

/**** Structs ****************************************************************/

struct WatchInfo
{
	UINT32	address;
	UINT8	cpu;
	UINT8	numElements;
	UINT8	elementBytes;
	UINT8	labelType;
	UINT8	displayType;
	
	UINT16	x, y;
	
	INT32	linkedCheat;
	
	char	label[256];
};

typedef struct WatchInfo	WatchInfo;

struct CheatAction
{
	UINT32	type;
	UINT32	address;
	UINT32	data;
	UINT32	extendData;
	UINT32	originalDataField;
	
	INT32	frameTimer;
	UINT32	lastValue;
	
	UINT32	flags;
	
	UINT8	** cachedPointer;
	UINT32	cachedOffset;
	
	char	* optionalName;
};

typedef struct CheatAction	CheatAction;

struct CheatEntry
{
	char			* name;
	char			* comment;
	
	INT32			actionListLength;
	CheatAction		* actionList;
	
	int				activationKey;
	
	UINT32			flags;
	int				selection;
};

typedef struct CheatEntry	CheatEntry;

struct SearchRegion
{
	UINT32	address;
	UINT32	length;

	UINT8	targetType;
	UINT8	targetIdx;

	UINT8	flags;

	UINT8	* cachedPointer;
	const struct Memory_WriteAddress
			* writeHandler;
	
	UINT8	* first;
	UINT8	* last;

	UINT8	* status;
	
	// 12345678 - 12345678 BANK31
	char	name[32];

	UINT32	numResults;
};

typedef struct SearchRegion	SearchRegion;

struct SearchInfo
{
	INT32			regionListLength;
	SearchRegion	* regionList;

	char			* name;

	INT8			bytes;	// 0 = 1, 1 = 2, 2 = 4, 3 = bit
	UINT8			swap;
	UINT8			sign;
	INT8			lhs;
	INT8			rhs;
	INT8			comparison;

	UINT8			targetType;	// cpu/region
	UINT8			targetIdx;	// cpu or region index

	UINT32			value;
	
	UINT8			searchSpeed;

	UINT32			numResults;

	INT32			currentRegionIdx;
	INT32			currentResultsPage;
};

typedef struct SearchInfo	SearchInfo;

struct CPUInfo
{
	UINT8	type;
	UINT8	dataBits;
	UINT8	addressBits;
	UINT8	addressCharsNeeded;
	UINT8	endianness;
};

typedef struct CPUInfo	CPUInfo;

struct MenuStringList
{
	char	** mainList;		// editable menu item lists
	char	** subList;
	char	* flagList;
	
	char	** mainStrings;		// lists of usable strings
	char	** subStrings;

	char	* buf;				// string storage

	UINT32	length;				// number of menu items supported
	UINT32	mainStringLength;	// max length of main string
	UINT32	subStringLength;	// max length of sub string
};

typedef struct MenuStringList	MenuStringList;

/**** Exported Globals *******************************************************/

int			he_did_cheat = 0;
char		* cheatfile = NULL;

/**** Local Globals **********************************************************/

static CheatEntry		* cheatList = NULL;
static INT32			cheatListLength = 0;

static WatchInfo		* watchList = NULL;
static INT32			watchListLength = 0;

static SearchInfo		* searchList = NULL;
static INT32			searchListLength = 0;
static INT32			currentSearchIdx = 0;

static CPUInfo			cpuInfoList[MAX_CPU];

static int				cheatEngineWasActive = 0;
static int				foundCheatDatabase = 0;
static int				cheatsDisabled = 0;

static char				mainDatabaseName[CHEAT_FILENAME_MAX_LEN + 1];

MenuStringList			menuStrings;

static const char *	kCheatNameTemplates[] =
{
	"Infinite Lives",
	"Infinite Lives PL1",
	"Infinite Lives PL2",
	"Infinite Time",
	"Infinite Time PL1",
	"Infinite Time PL2",
	"Invincibility",
	"Invincibility PL1",
	"Invincibility PL2",
	"Infinite Energy",
	"Infinite Energy PL1",
	"Infinite Energy PL2",
	"Select next level",
	"Select current level",
	"Infinite Ammo",
	"Infinite Ammo PL1",
	"Infinite Ammo PL2",
	"Infinite Bombs",
	"Infinite Bombs PL1",
	"Infinite Bombs PL2",
	"Infinite Smart Bombs",
	"Infinite Smart Bombs PL1",
	"Infinite Smart Bombs PL2",
	"Select Score PL1",
	"Select Score PL2",
	"Drain all Energy Now! PL1",
	"Drain all Energy Now! PL2",
	"Watch me for good answer",
	"Infinite",
	"Always have",
	"Get",
	"Lose",
	"Finish this",
	"---> <ENTER> To Edit <---",
	"\0"
};

static CPUInfo rawCPUInfo =
{
	0,			// type
	8,			// dataBits
	8,			// addressBits
	1,			// addressCharsNeeded
	CPU_IS_BE	// endianness
};

static const int kSearchByteIncrementTable[] =
{
	1,
	2,
	4,
	1
};

static const char * kSearchByteNameTable[] =
{
	"1",
	"2",
	"4",
	"Bit"
};

static const int	kSearchByteDigitsTable[] =
{
	2,
	4,
	8,
	1
};

static const UINT32 kSearchByteMaskTable[] = 
{
	0x000000FF,
	0x0000FFFF,
	0xFFFFFFFF,
	0x00000001
};

static const UINT32	kSearchByteSignBitTable[] =
{
	0x00000080,
	0x00008000,
	0x80000000,
	0x00000000
};

static const UINT32 kSearchByteUnsignedMaskTable[] =
{
	0x0000007F,
	0x00007FFF,
	0x7FFFFFFF,
	0x00000001
};

const char * kOperandNameTable[] =
{
	"Current Data",
	"Previous Data",
	"First Data",
	"Value"
}; 

const char * kComparisonNameTable[] =
{
	"Less",
	"Greater",
	"Equal",
	"Less Or Equal",
	"Greater Or Equal",
	"Not Equal"
};

/**** Function Prototypes ****************************************************/

static int		ShiftKeyPressed(void);
static int		ControlKeyPressed(void);
static int		AltKeyPressed(void);

static int		UIPressedRepeatThrottle(int code, int baseSpeed);

static char *	DoDynamicEditTextField(char * buf);
static UINT32	DoEditHexField(UINT32 data);

static UINT32	BCDToDecimal(UINT32 value);
static UINT32	DecimalToBCD(UINT32 value);

//static void		RebuildStringTables(void);
//static void		RequestStrings(UINT32 length, UINT32 mainStringLength, UINT32 subStringLength);
static void		InitStringTable(void);
static void		FreeStringTable(void);

static INT32	UserSelectValueMenu(struct mame_bitmap * bitmap, int selection, CheatEntry * entry);
static int		EnableDisableCheatMenu(struct mame_bitmap * bitmap, int selection);
static int		EditCheatMenu(struct mame_bitmap * bitmap, CheatEntry * entry, int selection);
static int		DoSearchMenu(struct mame_bitmap * bitmap, int selection, int startNew);
static int		AddEditCheatMenu(struct mame_bitmap * bitmap, int selection);
static int		ViewSearchResults(struct mame_bitmap * bitmap, int selection);
static int		ChooseWatch(struct mame_bitmap * bitmap, int selection);
//static int		EditWatch(struct mame_bitmap * bitmap, WatchInfo * entry, int selection);

static char *	CreateStringCopy(char * buf);

static void		ResizeCheatList(UINT32 newLength);
static void		ResizeCheatActionList(UINT32 idx, UINT32 newLength);
static void		AddCheatBefore(UINT32 idx);
static void		DeleteCheatAt(UINT32 idx);
static void		DisposeCheat(UINT32 idx);

static void		ResizeWatchList(UINT32 newLength);
//static void		AddWatchBefore(UINT32 idx);
//static void		DeleteWatchAt(UINT32 idx);
static void		DisposeWatch(UINT32 idx);

static void		ResizeSearchList(UINT32 newLength);
//static void		AddSearchBefore(UINT32 idx);
//static void		DeleteSearchAt(UINT32 idx);
static void		DisposeSearchRegions(SearchInfo * info);
static void		DisposeSearch(UINT32 idx);
static SearchInfo *	GetCurrentSearch(void);

static void		FillBufferFromRegion(SearchRegion * region, UINT8 * buf);
static UINT32	ReadRegionData(SearchRegion * region, UINT32 offset, UINT8 size, UINT8 swap);
static void		SetSearchRegionDefaultName(SearchRegion * region);
static void		BuildSearchRegions(SearchInfo * info);

static int		ConvertOldCode(int code, int cpu, int * data, int * extendData);
static int		MatchCommandCheatLine(char * buf);

static void		LoadCheatFile(char * fileName);
static void		LoadCheatDatabase(void);
static void		SaveCheat(CheatEntry * entry);

static UINT32	SearchSignExtend(SearchInfo * search, UINT32 value);
static UINT32	ReadSearchOperand(UINT8 type, SearchInfo * search, SearchRegion * region, UINT32 address);
static UINT8	DoSearchComparison(SearchInfo * search, UINT32 lhs, UINT32 rhs);
static void		InvalidateRegionOffset(SearchInfo * search, SearchRegion * region, UINT32 offset);
static UINT8	IsRegionOffsetValid(SearchInfo * search, SearchRegion * region, UINT32 offset);

static void		InitializeNewSearch(SearchInfo * search);
static void		UpdateSearch(SearchInfo * search);

static void		DoSearch(SearchInfo * search);

static UINT8 **	LookupHandlerMemory(UINT8 cpu, UINT32 address, UINT32 * outRelativeAddress);

static UINT32	DoCPURead(UINT8 cpu, UINT32 address, UINT8 bytes, UINT8 swap);
static UINT32	DoMemoryRead(UINT8 * buf, UINT32 address, UINT8 bytes, UINT8 swap, CPUInfo * info);
static void		DoCPUWrite(UINT32 data, UINT8 cpu, UINT32 address, UINT8 bytes, UINT8 swap);
static void		DoMemoryWrite(UINT32 data, UINT8 * buf, UINT32 address, UINT8 bytes, UINT8 swap, CPUInfo * info);

static UINT8	CPUNeedsSwap(UINT8 cpu);
static UINT8	RegionNeedsSwap(UINT8 region);

static CPUInfo *	GetCPUInfo(UINT8 cpu);
static CPUInfo *	GetRegionCPUInfo(UINT8 region);

static UINT32	SwapAddress(UINT32 address, UINT8 dataSize, CPUInfo * info);

static UINT32	ReadData(CheatAction * action);
static void		WriteData(CheatAction * action, UINT32 data);

static void		WatchCheatEntry(CheatEntry * entry);
static void		AddActionWatch(CheatAction * action, UINT8 associate);

static void		ResetAction(CheatAction * action);
static void		ActivateCheat(CheatEntry * entry);
static void		DeactivateCheat(CheatEntry * entry);

static void		DoCheatOperation(CheatAction * action);
static void		DoCheatAction(CheatAction * action);
static void		DoCheatEntry(CheatEntry * entry);

static void		UpdateAllCheatInfo(void);
static void		UpdateCheatInfo(CheatEntry * entry);

static int		IsAddressInRange(CheatAction * action, UINT32 length);

static void		BuildCPUInfoList(void);

/**** Imports ****************************************************************/

/**** Code *******************************************************************/

static int ShiftKeyPressed(void)
{
	return (code_pressed(KEYCODE_LSHIFT) || code_pressed(KEYCODE_RSHIFT));
}

static int ControlKeyPressed(void)
{
	return (code_pressed(KEYCODE_LCONTROL) || code_pressed(KEYCODE_RCONTROL));
}

static int AltKeyPressed(void)
{
	return (code_pressed(KEYCODE_LALT) || code_pressed(KEYCODE_RALT));
}

#if 1

#if OSD_READKEY_KLUDGE

/*	dirty hack until osd_readkey_unicode is supported in MAMEW
	re-implementation of osd_readkey_unicode */
static int ReadKeyAsync(int flush)
{
	int	code;
	
	if(flush)
	{
		while(code_read_async() != CODE_NONE) ;
		
		return 0;
	}
	
	while(1)
	{
		code = code_read_async();
		
		if(code == CODE_NONE)
		{
			return 0;
		}
		else if((code >= KEYCODE_A) && (code <= KEYCODE_Z))
		{
			if(ShiftKeyPressed())
			{
				return 'A' + (code - KEYCODE_A);
			}
			else
			{
				return 'a' + (code - KEYCODE_A);
			}
		}
		else if((code >= KEYCODE_0) && (code <= KEYCODE_9))
		{
			if(ShiftKeyPressed())
			{
				return ")!@#$%^&*("[code - KEYCODE_0];
			}
			else
			{
				return '0' + (code - KEYCODE_0);
			}
		}
		else if((code >= KEYCODE_0_PAD) && (code <= KEYCODE_0_PAD))
		{
			return '0' + (code - KEYCODE_0_PAD);
		}
		else if(code == KEYCODE_TILDE)
		{
			if(ShiftKeyPressed())
			{
				return '~';
			}
			else
			{
				return '`';
			}
		}
		else if(code == KEYCODE_MINUS)
		{
			if(ShiftKeyPressed())
			{
				return '_';
			}
			else
			{
				return '-';
			}
		}
		else if(code == KEYCODE_EQUALS)
		{
			if(ShiftKeyPressed())
			{
				return '+';
			}
			else
			{
				return '=';
			}
		}
		else if(code == KEYCODE_BACKSPACE)
		{
			return 0x08;
		}
		else if(code == KEYCODE_OPENBRACE)
		{
			if(ShiftKeyPressed())
			{
				return '{';
			}
			else
			{
				return '[';
			}
		}
		else if(code == KEYCODE_CLOSEBRACE)
		{
			if(ShiftKeyPressed())
			{
				return '}';
			}
			else
			{
				return ']';
			}
		}
		else if(code == KEYCODE_COLON)
		{
			if(ShiftKeyPressed())
			{
				return ':';
			}
			else
			{
				return ';';
			}
		}
		else if(code == KEYCODE_QUOTE)
		{
			if(ShiftKeyPressed())
			{
				return '\"';
			}
			else
			{
				return '\'';
			}
		}
		else if(code == KEYCODE_BACKSLASH)
		{
			if(ShiftKeyPressed())
			{
				return '|';
			}
			else
			{
				return '\\';
			}
		}
		else if(code == KEYCODE_COMMA)
		{
			if(ShiftKeyPressed())
			{
				return '<';
			}
			else
			{
				return ',';
			}
		}
		else if(code == KEYCODE_STOP)
		{
			if(ShiftKeyPressed())
			{
				return '>';
			}
			else
			{
				return '.';
			}
		}
		else if(code == KEYCODE_SLASH)
		{
			if(ShiftKeyPressed())
			{
				return '?';
			}
			else
			{
				return '/';
			}
		}
		else if(code == KEYCODE_SLASH_PAD)
		{
			return '/';
		}
		else if(code == KEYCODE_ASTERISK)
		{
			return '*';
		}
		else if(code == KEYCODE_MINUS_PAD)
		{
			return '-';
		}
		else if(code == KEYCODE_PLUS_PAD)
		{
			return '+';
		}
		else if(code == KEYCODE_SPACE)
		{
			return ' ';
		}
	}
}

#define osd_readkey_unicode ReadKeyAsync

#endif

#endif

static int UIPressedRepeatThrottle(int code, int baseSpeed)
{
	static int	lastCode = -1;
	static int	lastSpeed = -1;
	static int	incrementTimer = 0;
	int			pressed = 0;
	
	const int	kDelayRampTimer = 10;
	
	if(seq_pressed(input_port_type_seq(code)))
	{
		if(lastCode != code)
		{
			lastCode = code;
			lastSpeed = baseSpeed;
			incrementTimer = kDelayRampTimer * lastSpeed;
		}
		else
		{
			incrementTimer--;
			
			if(incrementTimer <= 0)
			{
				incrementTimer = kDelayRampTimer * lastSpeed;
				
				lastSpeed /= 2;
				if(lastSpeed < 1)
					lastSpeed = 1;
				
				pressed = 1;
			}
		}
	}
	else
	{
		if(lastCode == code)
		{
			lastCode = -1;
		}
	}
	
	return input_ui_pressed_repeat(code, lastSpeed);
}

static char * DoDynamicEditTextField(char * buf)
{
	char	code = osd_readkey_unicode(0) & 0xFF;

	if(code == 0x08)
	{
		if(buf)
		{
			UINT32	length = strlen(buf);

			if(length > 0)
			{
				buf[length - 1] = 0;

				if(length > 1)
				{
					buf = realloc(buf, length);
				}
				else
				{
					free(buf);

					buf = NULL;
				}
			}
		}
	}
	else if(isprint(code))
	{
		if(buf)
		{
			UINT32	length = strlen(buf);

			buf = realloc(buf, length + 2);

			buf[length] = code;
			buf[length + 1] = 0;
		}
		else
		{
			buf = malloc(2);

			buf[0] = code;
			buf[1] = 0;
		}
	}

	return buf;
}

static UINT32 DoEditHexField(UINT32 data)
{
	INT8	key;

	key = code_read_hex_async();

	if(key != -1)
	{
		data <<= 4;
		data |= key;
	}

	return data;
}

void InitCheat(void)
{
	logerror("InitCheat: OSD_READKEY_KLUDGE = %d LSB_FIRST = %d\n", OSD_READKEY_KLUDGE, LSB_FIRST);
	
	he_did_cheat =		0;

	cheatList =			NULL;
	cheatListLength =	0;

	watchList =			NULL;
	watchListLength =	0;

	searchList =		NULL;
	searchListLength =	0;

	currentSearchIdx =	0;
	foundCheatDatabase = 0;
	cheatsDisabled = 0;

	BuildCPUInfoList();
	
	LoadCheatDatabase();

	ResizeSearchList(1);
	ResizeWatchList(10);

	BuildSearchRegions(GetCurrentSearch());

	InitStringTable();
	
	/*
	{
		int		base = 0x406;
		UINT8	* ptr = memory_region(REGION_CPU1);

		logerror("InitCheat: %.8X: %.2X %.2X %.2X %.2X\n",	base,
															cpunum_read_byte(0, base + 0),
															cpunum_read_byte(0, base + 1),
															cpunum_read_byte(0, base + 2),
															cpunum_read_byte(0, base + 3));
		logerror("InitCheat: %.8X: %.8X\n", base, DoCPURead(0, base, 4, cpuInfoList[0].endianness ^ LSB_FIRST));

		if(ptr)
		{
			logerror("InitCheat: %.8X: %.2X %.2X %.2X %.2X\n",	base,
																ptr[base + 0],
																ptr[base + 1],
																ptr[base + 2],
																ptr[base + 3]);
			logerror("InitCheat: %.8X: %.8X\n", base, DoMemoryRead(&ptr[base], 4, CPUNeedsSwap(0)));
		}
		else
		{
			logerror("InitCheat: !ptr\n");
		}
	}
	*/

	// cps1 - xxxx00FF 4008xxxx - 00FF4008 - 00FF4008 - FF000840
	// cps2 - 4BF90040 800013FC - 00408000 - 00408000 - F94BFC13
}

void StopCheat(void)
{
	int	i;
	
	if(cheatList)
	{
		for(i = 0; i < cheatListLength; i++)
		{
			DisposeCheat(i);
		}
		
		free(cheatList);

		cheatList = NULL;
	}

	if(watchList)
	{
		for(i = 0; i < watchListLength; i++)
		{
			DisposeWatch(i);
		}

		free(watchList);

		watchList = NULL;
	}

	if(searchList)
	{
		for(i = 0; i < searchListLength; i++)
		{
			DisposeSearch(i);
		}

		free(searchList);

		searchList = NULL;
	}

	FreeStringTable();
}

int cheat_menu(struct mame_bitmap * bitmap, int selection)
{
	enum
	{
		kMenu_EnableDisable = 0,
		kMenu_AddEdit,
		kMenu_StartSearch,
		kMenu_ContinueSearch,
		kMenu_ViewResults,
		//kMenu_RestoreSearch,
		kMenu_ChooseWatch,
		//kMenu_DisplayHelp,
		//kMenu_Options,
		kMenu_Return,
		
		kMenu_Max
	};
	
	const char		* menu_item[kMenu_Max + 1];
	INT32			sel;
	UINT8			total;
	static INT32	submenu_choice = 0;
	
	cheatEngineWasActive = 1;
	
	total = 0;
	sel = selection - 1;
	
	if(submenu_choice)
	{
		switch(sel)
		{
			case kMenu_EnableDisable:
				submenu_choice = EnableDisableCheatMenu(bitmap, submenu_choice);
				break;
			
			case kMenu_AddEdit:
				submenu_choice = AddEditCheatMenu(bitmap, submenu_choice);
				break;
			
			case kMenu_StartSearch:
				submenu_choice = DoSearchMenu(bitmap, submenu_choice, 1);
				break;
			
			case kMenu_ContinueSearch:
				submenu_choice = DoSearchMenu(bitmap, submenu_choice, 0);
				break;

			case kMenu_ViewResults:
				submenu_choice = ViewSearchResults(bitmap, submenu_choice);
				break;
			
			case kMenu_ChooseWatch:
				submenu_choice = ChooseWatch(bitmap, submenu_choice);
				break;
			
			/*
			case kMenu_DisplayHelp:
				//submenu_choice = DisplayHelpFile(bitmap, submenu_choice);
				submenu_choice = 0;
				break;
			
			case kMenu_Options:
				//submenu_choice = SelectOptions(bitmap, submenu_choice);
				submenu_choice = 0;
				break;
			*/
			
			case kMenu_Return:
				submenu_choice = 0;
				sel = -1;
				break;
		}
		
		if(submenu_choice == -1)
			submenu_choice = 0;
		
		return sel + 1;
	}
	
	menu_item[total++] = ui_getstring(UI_enablecheat);
	menu_item[total++] = ui_getstring(UI_addeditcheat);
	menu_item[total++] = ui_getstring(UI_startcheat);
	menu_item[total++] = ui_getstring(UI_continuesearch);
	menu_item[total++] = ui_getstring(UI_viewresults);
	/*
	menu_item[total++] = ui_getstring(UI_restoreresults);
	menu_item[total++] = ui_getstring(UI_memorywatch);
	menu_item[total++] = ui_getstring(UI_generalhelp);
	menu_item[total++] = ui_getstring(UI_options);
	*/
	menu_item[total++] = ui_getstring(UI_returntomain);
	menu_item[total] = 0;
	
	ui_displaymenu(bitmap, menu_item, 0, 0, sel, 0);
	
	if(UIPressedRepeatThrottle(IPT_UI_DOWN, kVerticalKeyRepeatRate))
	{
		if(sel < (total - 1))
			sel++;
		else
			sel = 0;
	}
	
	if(UIPressedRepeatThrottle(IPT_UI_UP, kVerticalKeyRepeatRate))
	{
		if(sel > 0)
			sel--;
		else
			sel = total - 1;
	}
	
	if(input_ui_pressed(IPT_UI_SELECT))
	{
		switch(sel)
		{
			case kMenu_Return:
				submenu_choice = 0;
				sel = -1;
				break;

			/*
			case kMenu_RestoreSearch:
				RestoreSearch();
				break;
			*/

			default:
				submenu_choice = 1;
				schedule_full_refresh();
		}
	}
	
	if(input_ui_pressed(IPT_UI_CANCEL))
		sel = -1;
	if(input_ui_pressed(IPT_UI_CONFIGURE))
		sel = -2;
	
	if((sel == -1) || (sel == -2))
	{
		schedule_full_refresh();
	}
	
	return sel + 1;
}

static UINT32 BCDToDecimal(UINT32 value)
{
	UINT32	accumulator = 0;
	UINT32	multiplier = 1;
	int		i;
	
	for(i = 0; i < 8; i++)
	{
		accumulator += (value & 0xF) * multiplier;
		
		multiplier *= 10;
		value >>= 4;
	}
	
	return accumulator;
}

static UINT32 DecimalToBCD(UINT32 value)
{
	UINT32	accumulator = 0;
	UINT32	divisor = 10;
	int		i;
	
	for(i = 0; i < 8; i++)
	{
		UINT32	temp;
		
		temp = value % divisor;
		value -= temp;
		temp /= divisor / 10;
		
		accumulator += temp << (i * 4);
		
		divisor *= 10;
	}
	
	return accumulator;
}

/*
static void RebuildStringTables(void)
{
	UINT32	storageNeeded, i;
	char	* traverse;
	
	storageNeeded =				(menuStrings.mainStringLength + menuStrings.subStringLength) * menuStrings.length;

	menuStrings.mainList =		realloc(menuStrings.mainList,		sizeof(char *) * menuStrings.length);
	menuStrings.subList =		realloc(menuStrings.subList,		sizeof(char *) * menuStrings.length);
	menuStrings.flagList =		realloc(menuStrings.flagList,		sizeof(char)   * menuStrings.length);
	menuStrings.mainStrings =	realloc(menuStrings.mainStrings,	sizeof(char *) * menuStrings.length);
	menuStrings.subStrings =	realloc(menuStrings.subStrings,		sizeof(char *) * menuStrings.length);
	menuStrings.buf =			realloc(menuStrings.buf,			sizeof(char)   * storageNeeded);

	if(	!menuStrings.mainList ||
		!menuStrings.subList ||
		!menuStrings.flagList ||
		!menuStrings.mainStrings ||
		!menuStrings.subStrings ||
		!menuStrings.buf)
	{
		// memory allocation error

		exit(1);
	}
	
	traverse = menuStrings.buf;

	for(i = 0; i < menuStrings.length; i++)
	{
		menuStrings.mainStrings[i] = traverse;
		traverse += menuStrings.mainStringLength;
		
		menuStrings.subStrings[i] = traverse;
		traverse += menuStrings.subStringLength;
	}
}
*/

/*
static void RequestStrings(UINT32 length, UINT32 mainStringLength, UINT32 subStringLength)
{
	UINT8	changed = 0;

	if(menuStrings.length < length)
	{
		menuStrings.length = length;

		changed = 1;
	}

	if(menuStrings.mainStringLength < mainStringLength)
	{
		menuStrings.mainStringLength = mainStringLength;

		changed = 1;
	}

	if(menuStrings.subStringLength < subStringLength)
	{
		menuStrings.subStringLength = subStringLength;

		changed = 1;
	}

	if(changed)
	{
		RebuildStringTables();
	}
}
*/

static void InitStringTable(void)
{
	memset(&menuStrings, 0, sizeof(MenuStringList));
}

static void FreeStringTable(void)
{
	free(menuStrings.mainList);
	free(menuStrings.subList);
	free(menuStrings.flagList);
	free(menuStrings.mainStrings);
	free(menuStrings.subStrings);
	free(menuStrings.buf);

	memset(&menuStrings, 0, sizeof(MenuStringList));
}

static INT32 UserSelectValueMenu(struct mame_bitmap * bitmap, int selection, CheatEntry * entry)
{
	char					buf[2048];
	int						sel;
	CheatAction				* action;
	static INT32			value = -1;
	static int				firstTime = 1;
	int						delta = 0;
	int						displayValue;
	int						keyValue;
	
	sel =		selection - 1;
	
	action = &entry->actionList[0];
	
	if(firstTime)
	{
		value = action->data;
		
		if(TEST_FIELD(action->type, UserSelectBCD))
		{
			UINT32	min = EXTRACT_FIELD(action->type, UserSelectMinimumDisplay);
			UINT32	max = action->originalDataField;
			
			value = BCDToDecimal(value);
			value = DecimalToBCD(value);
			
			if(value < min)
				value = max;
			if(value > max)
				value = min;
		}
		
		firstTime = 0;
	}
	
	displayValue = value;
	
	if(TEST_FIELD(action->type, UserSelectMinimumDisplay))
	{
		if(TEST_FIELD(action->type, UserSelectBCD))
		{
			displayValue = BCDToDecimal(displayValue);
		}
		
		displayValue++;
		
		if(TEST_FIELD(action->type, UserSelectBCD))
		{
			displayValue = DecimalToBCD(displayValue);
		}
	}
	
	if(TEST_FIELD(action->type, UserSelectBCD))
	{
		sprintf(buf, "\t%s\n\t%.2X\n", ui_getstring(UI_search_select_value), displayValue);
	}
	else
	{
		sprintf(buf, "\t%s\n\t%.2X (%d)\n", ui_getstring(UI_search_select_value), displayValue, displayValue);
	}
	
	/* menu system, use the normal menu keys */
	strcat(buf, "\t");
	strcat(buf, ui_getstring(UI_lefthilight));
	strcat(buf, " ");
	strcat(buf, ui_getstring(UI_OK));
	strcat(buf, " ");
	strcat(buf, ui_getstring(UI_righthilight));
	
	ui_displaymessagewindow(bitmap, buf);
	
	if(UIPressedRepeatThrottle(IPT_UI_LEFT, kHorizontalFastKeyRepeatRate))
	{
		delta = -1;
	}
	if(UIPressedRepeatThrottle(IPT_UI_RIGHT, kHorizontalFastKeyRepeatRate))
	{
		delta = 1;
	}
	
	if(input_ui_pressed(IPT_UI_SELECT))
	{
		if(!firstTime)
		{
			int	i;
			
			for(i = 0; i < entry->actionListLength; i++)
			{
				CheatAction	* traverse = &entry->actionList[0];
				
				if(TEST_FIELD(traverse->type, UserSelectEnable))
				{
					traverse->data = value;
				}
			}
			
			ActivateCheat(entry);
		}
		
		firstTime = 1;
		sel = -1;
	}
	
	if(input_ui_pressed(IPT_UI_CANCEL))
	{
		firstTime = 1;
		sel = -1;
	}
	
	if(input_ui_pressed(IPT_UI_CONFIGURE))
	{
		firstTime = 1;
		sel = -2;
	}
	
	keyValue = code_read_hex_async();
	
	if(keyValue != -1)
	{
		if(TEST_FIELD(action->type, UserSelectBCD))
		{
			value *= 10;
			value &= 0xFF;
			value += keyValue;
		}
		else
		{
			value <<= 4;
			value &= 0xF0;
			value |= keyValue & 0x0F;
		}
		
		delta = 0;
	}
	
	if(delta)
	{
		UINT32	min = EXTRACT_FIELD(action->type, UserSelectMinimumDisplay);
		UINT32	max = action->originalDataField;
		
		if(TEST_FIELD(action->type, UserSelectBCD))
		{
			value = BCDToDecimal(value);
		}
		
		value += delta;
		
		if(value < min)
			value = max;
		if(value > max)
			value = min;
		
		if(TEST_FIELD(action->type, UserSelectBCD))
		{
			value = DecimalToBCD(value);
		}
	}
	
	if (sel == -1 || sel == -2)
	{
		schedule_full_refresh();
	}
	
	return sel + 1;
}

static int EnableDisableCheatMenu(struct mame_bitmap * bitmap, int selection)
{
	INT32			sel;
	static INT32	submenu_choice = 0;
	const char		* menu_item[MAX_LOADEDCHEATS + 2];
	const char		* menu_subitem[MAX_LOADEDCHEATS + 2];
	static char		buf[MAX_LOADEDCHEATS][80];	/* static to take load off stack */
	INT32			i;
	INT32			total = 0;
	CheatEntry		* entry;
	
	sel = selection - 1;
	
	/* If a submenu has been selected, go there */
	if(submenu_choice)
	{
		switch(submenu_choice)
		{
			case 1:
				//submenu_choice = CommentMenu(bitmap, submenu_choice, sel);
				submenu_choice = 0;
				break;
			
			case 2:
				submenu_choice = UserSelectValueMenu(bitmap, submenu_choice, &cheatList[sel]);
				//submenu_choice = 0;
				break;
		}
		
		if(submenu_choice == -1)
		{
			submenu_choice = 0;
			sel = -2;
		}
		
		return sel + 1;
	}
	
	/* No submenu active, do the watchpoint menu */
	for(i = 0; i < cheatListLength; i++)
	{
		CheatEntry	* traverse = &cheatList[i];
		
		if(traverse->name)
		{
			if(traverse->comment && traverse->comment[0])
			{
				sprintf(buf[total], "+%s", traverse->name);
				
				menu_item[total] = buf[total];
			}
			else
			{
				menu_item[total] = traverse->name;
			}
		}
		else
		{
			if(traverse->comment && traverse->comment[0])
				menu_item[total] = "+null name";
			else
				menu_item[total] = "null name";
		}
		
		menu_subitem[total] = NULL;
		
		if(traverse->flags & kCheatFlag_Select)
		{
			if((traverse->flags & kCheatFlag_OneShot) && !traverse->selection)
			{
				traverse->selection = 1;
			}
			
			if(traverse->selection && (traverse->selection < traverse->actionListLength))
			{
				menu_subitem[total] = traverse->actionList[traverse->selection].optionalName;
			}
			else
			{
				menu_subitem[total] = ui_getstring(UI_off);
			}
		}
		else
		{
			// add submenu options for all cheats that are not comments
			if(!(traverse->flags & kCheatFlag_Null))
			{
				if(traverse->flags & kCheatFlag_OneShot)
				{
					menu_subitem[total] = ui_getstring(UI_set);
				}
				else
				{
					if(traverse->flags & kCheatFlag_Active)
					{
						menu_subitem[total] = ui_getstring(UI_on);
					}
					else
					{
						menu_subitem[total] = ui_getstring(UI_off);
					}
				}
			}
		}
		
		total++;
	}

	if(cheatListLength == 0)
	{
		if(foundCheatDatabase)
		{
			menu_item[total] = "there are no cheats for this game";
			menu_subitem[total] = NULL;
			total++;
		}
		else
		{
			menu_item[total] = "cheat database not found";
			menu_subitem[total] = NULL;
			total++;

			menu_item[total] = "unzip it and place it in the MAME directory";
			menu_subitem[total] = NULL;
			total++;
		}
	}
	
	menu_item[total] = ui_getstring(UI_returntoprior);
	menu_subitem[total] = NULL;
	total++;
	
	menu_item[total] = 0;	/* terminate array */
	menu_subitem[total] = 0;
	
	if(sel < 0)
		sel = 0;
	if(sel > (total - 1))
		sel = total - 1;
	
	if(cheatListLength)
	{
		while(	(sel < total - 1) &&
				(cheatList[sel].flags & kCheatFlag_Null))
				sel++;
	}
	
	ui_displaymenu(bitmap, menu_item, menu_subitem, 0, sel, 0);
	
	if(UIPressedRepeatThrottle(IPT_UI_DOWN, kVerticalKeyRepeatRate))
	{
		sel++;
		
		if(sel >= total)
			sel = 0;
		
		if(cheatListLength)
		{
			while(	(sel < total - 1) &&
					(cheatList[sel].flags & kCheatFlag_Null))
				sel++;
		}
	}
	
	if(UIPressedRepeatThrottle(IPT_UI_UP, kVerticalKeyRepeatRate))
	{
		sel--;
		
		if(sel < 0)
		{
			sel = total - 1;
		}
		else
		{
			if(cheatListLength)
			{
				while(	(sel != total - 1) &&
						(cheatList[sel].flags & kCheatFlag_Null))
				{
					sel--;
					
					if(sel < 0)
						sel = total - 1;
				}
			}
		}
	}
	
	if(UIPressedRepeatThrottle(IPT_UI_PAN_UP, kVerticalKeyRepeatRate))
	{
		sel -= Machine->uiheight / (3 * Machine->uifontheight / 2) - 1;
		
		if(sel < 0)
		{
			sel = 0;
			
			if(cheatListLength)
			{
				while(	(sel < total - 1) &&
						(cheatList[sel].flags & kCheatFlag_Null))
					sel++;
			}
		}
		else
		{
			if(cheatListLength)
			{
				while(	(sel != total - 1) &&
						(cheatList[sel].flags & kCheatFlag_Null))
				{
					sel--;
					
					if(sel < 0)
						sel = total - 1;
				}
			}
		}
	}
	
	if(UIPressedRepeatThrottle(IPT_UI_PAN_DOWN, kVerticalKeyRepeatRate))
	{
		sel += Machine->uiheight / (3 * Machine->uifontheight / 2) - 1;
		
		if(sel >= total)
		{
			sel = total - 1;
		}
		else
		{
			if(cheatListLength)
			{
				while(	(sel < total - 1) &&
						(cheatList[sel].flags & kCheatFlag_Null))
					sel++;
			}
		}
	}
	
	if(	(sel >= 0) &&
		(sel < cheatListLength))
		entry = &cheatList[sel];
	else
		entry = NULL;

	if(UIPressedRepeatThrottle(IPT_UI_LEFT, kHorizontalSlowKeyRepeatRate))
	{
		if((sel < (total - 1)) && entry)
		{
			if(entry->flags & kCheatFlag_Select)
			{
				entry->selection--;

				if(entry->flags & kCheatFlag_OneShot)
				{
					if(entry->selection <= 0)
						entry->selection = entry->actionListLength - 1;
				}
				else
				{
					if(entry->selection < 0)
						entry->selection = entry->actionListLength - 1;
					
					if(entry->selection == 0)
					{
						DeactivateCheat(entry);
					}
					else
					{
						ActivateCheat(entry);
					}
				}
			}
			else
			{
				if(	!(entry->flags & kCheatFlag_Null) &&
					!(entry->flags & kCheatFlag_OneShot))
				{
					int active = entry->flags & kCheatFlag_Active;
					
					active ^= 0x01;
					
					/* get the user's selected value if needed */
					if((entry->flags & kCheatFlag_UserSelect) && active)
					{
						submenu_choice = 2;
						schedule_full_refresh();
					}
					else
					{
						if(active)
							ActivateCheat(entry);
						else
							DeactivateCheat(entry);
					}
				}
			}
		}
	}
	
	if(UIPressedRepeatThrottle(IPT_UI_RIGHT, kHorizontalSlowKeyRepeatRate))
	{
		if((sel < (total - 1)) && entry)
		{
			if(entry->flags & kCheatFlag_Select)
			{
				entry->selection++;

				if(entry->flags & kCheatFlag_OneShot)
				{
					if(entry->selection >= entry->actionListLength)
					{
						entry->selection = 1;

						if(entry->selection >= entry->actionListLength)
							entry->selection = 0;
					}
				}
				else
				{
					if(entry->selection >= entry->actionListLength)
					{
						entry->selection = 0;
						
						DeactivateCheat(entry);
					}
					else
					{
						ActivateCheat(entry);
					}
				}
			}
			else
			{
				if(	!(entry->flags & kCheatFlag_Null) &&
					!(entry->flags & kCheatFlag_OneShot))
				{
					int active = entry->flags & kCheatFlag_Active;
					
					active ^= 0x01;
					
					/* get the user's selected value if needed */
					if((entry->flags & kCheatFlag_UserSelect) && active)
					{
						submenu_choice = 2;
						schedule_full_refresh();
					}
					else
					{
						if(active)
							ActivateCheat(entry);
						else
							DeactivateCheat(entry);
					}
				}
			}
		}
	}
	
	if(input_ui_pressed(IPT_UI_SELECT))
	{
		if(sel == (total - 1))
		{
			/* return to prior menu */
			submenu_choice = 0;
			sel = -1;
		}
		else if((sel < (total - 1)) && entry)
		{
			if(ShiftKeyPressed())
			{
				if((entry->flags & kCheatFlag_Null) && (cheatList[sel].comment[0] != 0x00))
				{
					submenu_choice = 1;
					schedule_full_refresh();
				}
				else
				{
					ActivateCheat(&cheatList[sel]);
				}
			}
			else
			{
				if(entry->flags & kCheatFlag_UserSelect)
				{
					submenu_choice = 2;
					schedule_full_refresh();
				}
				else
				{
					ActivateCheat(&cheatList[sel]);
				}
			}
		}
	}
	
	if(input_ui_pressed(IPT_UI_WATCH_VALUE))
	{
		if((sel < total - 1) && entry)
		{
			//WatchCheat(sel);
		}
	}
	
	/* Cancel pops us up a menu level */
	if(input_ui_pressed(IPT_UI_CANCEL))
		sel = -1;

	/* The UI key takes us all the way back out */
	if(input_ui_pressed(IPT_UI_CONFIGURE))
		sel = -2;
	
	if(sel == -1 || sel == -2)
	{
		schedule_full_refresh();
	}
	
	return sel + 1;
}

static int EditCheatMenu(struct mame_bitmap * bitmap, CheatEntry * entry, int selection)
{
	const char *	kTypeNames[] =
	{
		"Normal/Delay",
		"Wait",
		"Ignore Decrement",
		"Watch",
		"Comment",
		"Select"
	};
	
	const char *	kNumbersTable[] =
	{
		"0",	"1",	"2",	"3",	"4",	"5",	"6",	"7",
		"8",	"9",	"10",	"11",	"12",	"13",	"14",	"15",
		"16",	"17",	"18",	"19",	"20",	"21",	"22",	"23",
		"24",	"25",	"26",	"27",	"28",	"29",	"30",	"31"
	};

	const char *	kOperationNames[] =
	{
		"Write",
		"Add/Subtract",
		"Force Range",
		"Set/Clear Bits",
		"Unused (4)",
		"Unused (5)",
		"Unused (6)",
		"Null"
	};

	const char *	kAddSubtractNames[] =
	{
		"Add",
		"Subtract"
	};

	const char *	kSetClearNames[] =
	{
		"Set",
		"Clear"
	};

	const char *	kPrefillNames[] =
	{
		"None",
		"FF",
		"00",
		"01"
	};

	const char *	kEndiannessNames[] =
	{
		"Normal",
		"Swap"
	};

	const char *	kRegionNames[] =
	{
		"CPU1",		"CPU2",		"CPU3",		"CPU4",		"CPU5",		"CPU6",		"CPU7",		"CPU8",
		"GFX1",		"GFX2",		"GFX3",		"GFX4",		"GFX5",		"GFX6",		"GFX7",		"GFX8",
		"PROMS",
		"SOUND1",	"SOUND2",	"SOUND3",	"SOUND4",	"SOUND5",	"SOUND6",	"SOUND7",	"SOUND8",
		"USER1",	"USER2",	"USER3",	"USER4",	"USER5",	"USER6",	"USER7",	"USER8"
	};

	const char *	kLocationNames[] =
	{
		"Normal",
		"Region",
		"Mapped Memory",
		"Custom",
		"Relative Address",
		"Unused (5)",
		"Unused (6)",
		"Unused (7)"
	};

	const char *	kCustomLocationNames[] =
	{
		"Comment",
		"EEPROM",
		"Select",
		"Unused (3)",	"Unused (4)",	"Unused (5)",	"Unused (6)",	"Unused (7)",
		"Unused (8)",	"Unused (9)",	"Unused (10)",	"Unused (11)",	"Unused (12)",
		"Unused (13)",	"Unused (14)",	"Unused (15)",	"Unused (16)",	"Unused (17)",
		"Unused (18)",	"Unused (19)",	"Unused (20)",	"Unused (21)",	"Unused (22)",
		"Unused (23)",	"Unused (24)",	"Unused (25)",	"Unused (26)",	"Unused (27)",
		"Unused (28)",	"Unused (29)",	"Unused (30)",	"Unused (31)"
	};

	const char *	kKeycodeNames[] =
	{
		"A",		"B",		"C",		"D",		"E",		"F",
		"G",		"H",		"I",		"J",		"K",		"L",
		"M",		"N",		"O",		"P",		"Q",		"R",
		"S",		"T",		"U",		"V",		"W",		"X",
		"Y",		"Z",		"0",		"1",		"2",		"3",
		"4",		"5",		"6",		"7",		"8",		"9",
		"[0]",		"[1]",		"[2]",		"[3]",		"[4]",
		"[5]",		"[6]",		"[7]",		"[8]",		"[9]",
		"F1",		"F2",		"F3",		"F4",		"F5",
		"F6",		"F7",		"F8",		"F9",		"F10",
		"F11",		"F12",
		"ESC",		"~",		"-",		"=",		"BACKSPACE",
		"TAB",		"[",		"]",		"ENTER",	":",
		"\'",		"\\",		"\\",		",",		".",
		"/",		"SPACE",	"INS",		"DEL",
		"HOME",		"END",		"PGUP",		"PGDN",		"LEFT",
		"RIGHT",	"UP",		"DOWN",
		"[/]",		"[*]",		"[-]",		"[+]",
		"[DEL]",	"[ENT]",	"PTSCR",	"PAUSE",
		"LSHIFT",	"RSHIFT",	"LCONTROL",	"RCONTROL",
		"LALT",		"RALT",		"SCRLLK",	"NUMLK",	"CAPSLK",
		"LWIN",		"RWIN",		"MENU"
	};

	enum
	{
		kType_Name = 0,					//	text		name
										//	NOTE:	read from base cheat (for idx == 0)
		kType_ExtendName,				//	text		extraName
										//	NOTE:	read from subcheat for (idx > 0) && (cheat[0].type == Select)
		kType_Comment,					//	text		comment
										//	NOTE:	read from base cheat (for idx == 0)
		kType_ActivationKey,			//	key			activationKey
										//	NOTE:	read from base cheat (for idx == 0)
		kType_Type,						//	select		Type				Normal/Delay - Wait - Ignore Decrement - Watch -
										//									Comment - Select
										//	NOTE: also uses location type field for comment and select
		// if((Type != Comment) && (Type != Select))
			// if(Type != Watch)
				kType_OneShot,			//	select		OneShot				Off - On
				kType_RestorePreviousValue,
										//	select		RestorePreviousValue
										//									Off - On
			// if((Type == Normal/Delay) || (Type == Wait))
				kType_Delay,			//	value		TypeParameter		0 - 7
			// if(Type == Ignore Decrement)
				kType_IgnoreDecrementBy,//	value		TypeParameter		0 - 7
			// if(Type == Watch)
				kType_WatchSize,		//	value		TypeParameter		0 - 7
				// and set operation to null
			// else
				kType_Operation,		//	select		Operation			Write - Add/Subtract - Force Range - Set/Clear Bits -
										//									Null
			// if((Operation == Write) && (LocationType != Relative Address))
				kType_WriteMask,		//	value		extendData			0x00000000 - 0xFFFFFFFF
			// if(Operation == Add/Subtract)
				kType_AddSubtract,		//	select		OperationParameter	Add - Subtract
				// if(LocationType != Relative Address)
					// if(OperationParameter == Add)
						kType_AddMaximum,
										//	value		extendData			0x00000000 - 0xFFFFFFFF
					// else
						kType_SubtractMinimum,
										//	value		extendData			0x00000000 - 0xFFFFFFFF
			// if((Operation == Force Range) && (LocationType != Relative Address))
				kType_RangeMinimum,		//	value		extendData			0x00 - 0xFF
										//	NOTE: value is packed in to upper byte of extendData
				kType_RangeMaximum,		//	value		extendData			0x00 - 0xFF
										//	NOTE: value is packed in to lower byte of extendData
			// if(Operation == Set/Clear)
				kType_SetClear,			//	select		OperationParameter	Set - Clear
			// if(Operation != Null)
				kType_Data,
				kType_UserSelect,		//	select		UserSelectEnable	Off - On
				// if(UserSelect == On)
					kType_UserSelectMinimumDisp,
										//	value		UserSelectMinimumDisplay
										//									0 - 1
					kType_UserSelectMinimum,
										//	value		UserSelectMinimum	0 - 1
					kType_UserSelectBCD,//	select		UserSelectBCD		Off - On
					kType_Prefill,		//	select		UserSelectPrefill	None - FF - 00 - 01
				// if(idx > 0)
					kType_CopyPrevious,	//	select		LinkCopyPreviousValue
										//									Off - On
				kType_ByteLength,		//	value		BytesUsed			1 - 4
				// if(bytesUsed > 0)
					kType_Endianness,	//	select		Endianness			Normal - Swap
				kType_LocationType,		//	select		LocationType		Normal - Region - Mapped Memory - EEPROM -
										//									Relative Address
										//	NOTE: also uses LocationParameter for EEPROM type
				// if(LocationType == Normal)
					kType_CPU,			//	value		LocationParameter	0 - 31
				// if(LocationType == Region)
					kType_Region,		//	select		LocationParameter	CPU1 - CPU2 - CPU3 - CPU4 - CPU5 - CPU6 - CPU7 -
										//									CPU8 - GFX1 - GFX2 - GFX3 - GFX4 - GFX5 - GFX6 -
										//									GFX7 - GFX8 - PROMS - SOUND1 - SOUND2 - SOUND3 -
										//									SOUND4 - SOUND5 - SOUND6 - SOUND7 - SOUND8 -
										//									USER1 - USER2 - USER3 - USER4 - USER5 - USER6 -
										//									USER7
				// if(LocationType == RelativeAddress)
					kType_PackedCPU,	//	value		LocationParameter	0 - 7
										//	NOTE: packed in to upper three bits of LocationParameter
					kType_PackedSize,	//	value		LocationParameter	1 - 4
										//	NOTE: packed in to lower two bits of LocationParameter
					kType_AddressIndex,	//	value		extendData			-0x80000000 - 0x7FFFFFFF
				kType_Address,
		
		kType_Return,
		kType_Divider,

		kType_Max
	};
	
	struct menuItemInfoStruct
	{
		UINT8	subcheat;
		UINT8	fieldType;
	};

	typedef struct menuItemInfoStruct	menuItemInfoStruct;
	
	INT32				sel;
	const char			* menuItem[(MAX_SUBCHEATS * kType_Max) + 2];
	const char			* menuSubItem[(MAX_SUBCHEATS * kType_Max) + 2];
	char				flagBuf[(MAX_SUBCHEATS * kType_Max) + 2];
	menuItemInfoStruct	menuItemInfo[(MAX_SUBCHEATS * kType_Max) + 2];
	static char			extendDataBuf[MAX_SUBCHEATS][10];	// FFFFFFFF (-80000000)
	static char			addressBuf[MAX_SUBCHEATS][9];		// FFFFFFFF
	static char			dataBuf[MAX_SUBCHEATS][24];			// 80000000 (-2147483648)
	INT32				i;
	INT32				total = 0;
	menuItemInfoStruct	* info = NULL;
	CheatAction			* action = NULL;
	UINT8				isSelect = 0;
	static UINT8		editActive = 0;
	UINT32				increment = 1;
	UINT8				dirty = 0;
	static INT32		currentNameTemplate = 0;

	sel = selection - 1;

	memset(flagBuf, 0, sizeof(char) * ((MAX_SUBCHEATS * kType_Max) + 2));

	usrintf_showmessage("%d %.8X", entry->activationKey, entry->flags);

	for(i = 0; i < entry->actionListLength; i++)
	{
		CheatAction	* traverse = &entry->actionList[i];
		
		UINT32		type =					EXTRACT_FIELD(traverse->type, Type);
		UINT32		typeParameter =			EXTRACT_FIELD(traverse->type, TypeParameter);
		UINT32		operation =				EXTRACT_FIELD(traverse->type, Operation) |
											EXTRACT_FIELD(traverse->type, OperationExtend) << 2;
		UINT32		operationParameter =	EXTRACT_FIELD(traverse->type, OperationParameter);
		UINT32		locationType =			EXTRACT_FIELD(traverse->type, LocationType);
		UINT32		locationParameter =		EXTRACT_FIELD(traverse->type, LocationParameter);
		
		UINT8		wasCommentOrSelect =	0;
		
		if(isSelect)
		{
			// do extend name field

			menuItemInfo[total].subcheat = i;
			menuItemInfo[total].fieldType = kType_ExtendName;
			menuItem[total] = "Name";

			if(traverse->optionalName)
				menuSubItem[total] = traverse->optionalName;
			else
				menuSubItem[total] = "(none)";
			
			total++;
		}

		if(i == 0)
		{
			{
				// do name field
				
				menuItemInfo[total].subcheat = i;
				menuItemInfo[total].fieldType = kType_Name;
				menuItem[total] = "Name";

				if(entry->name)
					menuSubItem[total] = entry->name;
				else
					menuSubItem[total] = "(none)";

				total++;
			}

			{
				// do comment field
				
				menuItemInfo[total].subcheat = i;
				menuItemInfo[total].fieldType = kType_Comment;
				menuItem[total] = "Comment";

				if(entry->comment)
					menuSubItem[total] = entry->comment;
				else
					menuSubItem[total] = "(none)";

				total++;
			}

			{
				// do activation key field
				
				menuItemInfo[total].subcheat = i;
				menuItemInfo[total].fieldType = kType_ActivationKey;
				menuItem[total] = "Activation Key";

				if(entry->activationKey < __code_key_first)
					entry->activationKey = __code_key_last;
				if(entry->activationKey > __code_key_last)
					entry->activationKey = __code_key_first;

				if(	//(entry->activationKey >= __code_key_first) &&
					//(entry->activationKey <= __code_key_last) &&
					(entry->flags & kCheatFlag_HasActivationKey))
				{
					menuSubItem[total] = kKeycodeNames[entry->activationKey - __code_key_first];
				}
				else
				{
					menuSubItem[total] = "(none)";
				}

				total++;
			}

			// check for select cheat

			if(	(locationType == kLocation_Custom) &&
				(locationParameter == kCustomLocation_Select))
				isSelect = 1;
		}

		{
			// do type field

			menuItemInfo[total].subcheat = i;
			menuItemInfo[total].fieldType = kType_Type;
			menuItem[total] = "Type";
			
			if(locationType == kLocation_Custom)
			{
				if(locationParameter == kCustomLocation_Comment)
				{
					wasCommentOrSelect = 1;

					menuSubItem[total] = kTypeNames[4];
				}
				else if(locationParameter == kCustomLocation_Select)
				{
					wasCommentOrSelect = 1;

					menuSubItem[total] = kTypeNames[5];
				}
				else
				{
					menuSubItem[total] = kTypeNames[type & 3];
				}
			}
			else
			{
				menuSubItem[total] = kTypeNames[type & 3];
			}

			total++;
		}
		
		if(!wasCommentOrSelect)
		{
			if(type != kType_Watch)
			{
				{
					// do one shot field

					menuItemInfo[total].subcheat = i;
					menuItemInfo[total].fieldType = kType_OneShot;
					menuItem[total] = "One Shot";
					menuSubItem[total] = ui_getstring(TEST_FIELD(traverse->type, OneShot) ? UI_on : UI_off);

					total++;
				}

				{
					// do restore previous value field

					menuItemInfo[total].subcheat = i;
					menuItemInfo[total].fieldType = kType_RestorePreviousValue;
					menuItem[total] = "Restore Previous Value";
					menuSubItem[total] = ui_getstring(TEST_FIELD(traverse->type, RestorePreviousValue) ? UI_on : UI_off);

					total++;
				}
			}

			if((type == kType_NormalOrDelay) || (type == kType_WaitForModification))
			{
				// do delay field

				menuItemInfo[total].subcheat = i;
				menuItemInfo[total].fieldType = kType_Delay;
				menuItem[total] = "Delay";
				menuSubItem[total] = kNumbersTable[typeParameter];

				total++;
			}

			if(type == kType_IgnoreIfDecrementing)
			{
				// do ignore decrement by field

				menuItemInfo[total].subcheat = i;
				menuItemInfo[total].fieldType = kType_IgnoreDecrementBy;
				menuItem[total] = "Ignore Decrement By";
				menuSubItem[total] = kNumbersTable[typeParameter];

				total++;
			}

			if(type == kType_Watch)
			{
				// do watch size field

				menuItemInfo[total].subcheat = i;
				menuItemInfo[total].fieldType = kType_WatchSize;
				menuItem[total] = "Watch Size";
				menuSubItem[total] = kNumbersTable[typeParameter];

				total++;
			}
			else
			{
				{
					// do operation field

					menuItemInfo[total].subcheat = i;
					menuItemInfo[total].fieldType = kType_Operation;
					menuItem[total] = "Operation";
					menuSubItem[total] = kOperationNames[operation];

					total++;
				}

				if((operation == kOperation_WriteMask) && (locationType != kLocation_IndirectIndexed))
				{
					// do mask field

					sprintf(extendDataBuf[i], "%.8X", traverse->extendData);

					menuItemInfo[total].subcheat = i;
					menuItemInfo[total].fieldType = kType_WriteMask;
					menuItem[total] = "Mask";
					menuSubItem[total] = extendDataBuf[i];

					total++;
				}

				if(operation == kOperation_AddSubtract)
				{
					{
						// do add/subtract field

						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_AddSubtract;
						menuItem[total] = "Add/Subtract";
						menuSubItem[total] = kAddSubtractNames[operationParameter];

						total++;
					}

					if(locationType != kLocation_IndirectIndexed)
					{
						if(operationParameter)
						{
							// do subtract minimum field

							sprintf(extendDataBuf[i], "%.8X", traverse->extendData);

							menuItemInfo[total].subcheat = i;
							menuItemInfo[total].fieldType = kType_SubtractMinimum;
							menuItem[total] = "Minimum Boundary";
							menuSubItem[total] = extendDataBuf[i];

							total++;
						}
						else
						{
							// do add maximum field

							sprintf(extendDataBuf[i], "%.8X", traverse->extendData);

							menuItemInfo[total].subcheat = i;
							menuItemInfo[total].fieldType = kType_AddMaximum;
							menuItem[total] = "Maximum Boundary";
							menuSubItem[total] = extendDataBuf[i];

							total++;
						}
					}
				}

				if((operation == kOperation_ForceRange) && (locationType != kLocation_IndirectIndexed))
				{
					{
						// do range minimum field

						sprintf(extendDataBuf[i], "%.2X", (traverse->extendData >> 8) & 0xFF);

						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_RangeMinimum;
						menuItem[total] = "Range Minimum";
						menuSubItem[total] = extendDataBuf[i];

						total++;
					}

					{
						// do range maximum field

						sprintf(extendDataBuf[i] + 3, "%.2X", (traverse->extendData >> 8) & 0xFF);

						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_RangeMaximum;
						menuItem[total] = "Range Maximum";
						menuSubItem[total] = extendDataBuf[i] + 3;

						total++;
					}
				}

				if(operation == kOperation_SetOrClearBits)
				{
					// do set/clear field

					menuItemInfo[total].subcheat = i;
					menuItemInfo[total].fieldType = kType_SetClear;
					menuItem[total] = "Set/Clear";
					menuSubItem[total] = kSetClearNames[operationParameter];

					total++;
				}

				if(operation != kOperation_None)
				{
					UINT32	userSelect =		TEST_FIELD(traverse->type, UserSelectEnable);
					UINT32	bytesUsed =			EXTRACT_FIELD(traverse->type, BytesUsed);

					{
						// do data field

						sprintf(dataBuf[i], "%.8X (%d)", traverse->data, traverse->data);
						
						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_Data;
						menuItem[total] = "Data";
						menuSubItem[total] = dataBuf[i];

						total++;
					}
					
					{
						// do user select field

						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_UserSelect;
						menuItem[total] = "User Select";
						menuSubItem[total] = ui_getstring(userSelect ? UI_on : UI_off);

						total++;
					}

					if(userSelect)
					{
						{
							// do user select minimum displayed value field

							menuItemInfo[total].subcheat = i;
							menuItemInfo[total].fieldType = kType_UserSelectMinimumDisp;
							menuItem[total] = "Minimum Displayed Value";
							menuSubItem[total] = kNumbersTable[EXTRACT_FIELD(traverse->type, UserSelectMinimumDisplay)];

							total++;
						}

						{
							// do user select minimum value field

							menuItemInfo[total].subcheat = i;
							menuItemInfo[total].fieldType = kType_UserSelectMinimum;
							menuItem[total] = "Minimum Value";
							menuSubItem[total] = kNumbersTable[EXTRACT_FIELD(traverse->type, UserSelectMinimum)];

							total++;
						}

						{
							// do user select BCD field

							menuItemInfo[total].subcheat = i;
							menuItemInfo[total].fieldType = kType_UserSelectBCD;
							menuItem[total] = "BCD";
							menuSubItem[total] = ui_getstring(TEST_FIELD(traverse->type, UserSelectBCD) ? UI_on : UI_off);

							total++;
						}

						{
							// do prefill field

							menuItemInfo[total].subcheat = i;
							menuItemInfo[total].fieldType = kType_Prefill;
							menuItem[total] = "Prefill";
							menuSubItem[total] = kPrefillNames[EXTRACT_FIELD(traverse->type, Prefill)];

							total++;
						}
					}
					
					if(i > 0)
					{
						// do copy previous value field

						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_CopyPrevious;
						menuItem[total] = "Copy Previous Value";
						menuSubItem[total] = ui_getstring(TEST_FIELD(traverse->type, LinkCopyPreviousValue) ? UI_on : UI_off);

						total++;
					}

					{
						// do byte length field

						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_ByteLength;
						menuItem[total] = "Byte Length";
						menuSubItem[total] = kNumbersTable[bytesUsed + 1];

						total++;
					}
					
					if(bytesUsed > 0)
					{
						// do endianness field

						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_Endianness;
						menuItem[total] = "Endianness";
						menuSubItem[total] = kEndiannessNames[EXTRACT_FIELD(traverse->type, Endianness)];

						total++;
					}

					{
						// do location type field

						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_LocationType;
						menuItem[total] = "Location";

						if(locationType == kLocation_Custom)
							menuSubItem[total] = kCustomLocationNames[locationParameter];
						else
							menuSubItem[total] = kLocationNames[locationType];

						total++;
					}

					if(locationType == kLocation_Standard)
					{
						// do cpu field

						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_CPU;
						menuItem[total] = "CPU";
						menuSubItem[total] = kNumbersTable[locationParameter];

						total++;
					}

					if(locationType == kLocation_MemoryRegion)
					{
						// do region field

						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_Region;
						menuItem[total] = "Region";
						menuSubItem[total] = kRegionNames[locationParameter];

						total++;
					}

					if(locationType == kLocation_IndirectIndexed)
					{
						{
							// do packed CPU field

							menuItemInfo[total].subcheat = i;
							menuItemInfo[total].fieldType = kType_PackedCPU;
							menuItem[total] = "CPU";
							menuSubItem[total] = kNumbersTable[(locationParameter >> 2) & 7];

							total++;
						}

						{
							// do packed size field

							menuItemInfo[total].subcheat = i;
							menuItemInfo[total].fieldType = kType_PackedSize;
							menuItem[total] = "Address Size";
							menuSubItem[total] = kNumbersTable[(locationParameter & 3) + 1];

							total++;
						}

						{
							// do address index field

							// swap if negative
							if(traverse->extendData & 0x80000000)
							{
								int	temp = traverse->extendData;

								temp = -temp;

								sprintf(extendDataBuf[i], "-%.8X", temp);
							}
							else
							{
								sprintf(extendDataBuf[i], "%.8X", traverse->extendData);
							}

							menuItemInfo[total].subcheat = i;
							menuItemInfo[total].fieldType = kType_AddressIndex;
							menuItem[total] = "Address Index";
							menuSubItem[total] = extendDataBuf[i];

							total++;
						}
					}

					{
						// do address field

						sprintf(addressBuf[i], "%.8X", traverse->address);
						
						menuItemInfo[total].subcheat = i;
						menuItemInfo[total].fieldType = kType_Address;
						menuItem[total] = "Address";
						menuSubItem[total] = addressBuf[i];

						total++;
					}
				}
			}
		}

		if(i < (entry->actionListLength - 1))
		{
			menuItemInfo[total].subcheat = i;
			menuItemInfo[total].fieldType = kType_Divider;
			menuItem[total] = "===";
			menuSubItem[total] = NULL;

			total++;
		}
	}

	menuItemInfo[total].subcheat =	0;
	menuItemInfo[total].fieldType =	kType_Return;
	menuItem[total] =				ui_getstring(UI_returntoprior);
	menuSubItem[total] =			NULL;
	total++;

	menuItemInfo[total].subcheat =	0;
	menuItemInfo[total].fieldType =	kType_Return;
	menuItem[total] =				NULL;
	menuSubItem[total] =			NULL;
	
	if(sel < 0)
		sel = 0;
	if(sel >= total)
		sel = total - 1;
	
	info = &menuItemInfo[sel];
	action = &entry->actionList[info->subcheat];

	if(editActive)
		flagBuf[sel] = 1;

	ui_displaymenu(bitmap, menuItem, menuSubItem, flagBuf, sel, 0);
	
	if(AltKeyPressed())
		increment <<= 4;
	if(ControlKeyPressed())
		increment <<= 8;
	if(ShiftKeyPressed())
		increment <<= 16;

	if(UIPressedRepeatThrottle(IPT_UI_LEFT, kHorizontalSlowKeyRepeatRate))
	{
		editActive = 0;
		dirty = 1;
		
		switch(info->fieldType)
		{
			case kType_Name:
				currentNameTemplate--;

				if(currentNameTemplate < 0)
				{
					currentNameTemplate = 0;

					while(kCheatNameTemplates[currentNameTemplate + 1])
					{
						currentNameTemplate++;
					}
				}

				entry->name = realloc(entry->name, strlen(kCheatNameTemplates[currentNameTemplate]) + 1);
				strcpy(entry->name, kCheatNameTemplates[currentNameTemplate]);
				break;

			case kType_ActivationKey:
				entry->activationKey--;

				if(entry->activationKey < __code_key_first)
					entry->activationKey = __code_key_last;
				if(entry->activationKey > __code_key_last)
					entry->activationKey = __code_key_first;

				entry->flags |= kCheatFlag_HasActivationKey;

				logerror("-- set flag %.8X\n", entry->flags);
				break;

			case kType_Type:
			{
				UINT8	handled = 0;

				if(EXTRACT_FIELD(action->type, LocationType) == kLocation_Custom)
				{
					UINT32	locationParameter = EXTRACT_FIELD(action->type, LocationParameter);
					
					if(locationParameter == kCustomLocation_Comment)
					{
						SET_FIELD(action->type, LocationParameter, 0);
						SET_FIELD(action->type, LocationType, kLocation_Standard);
						SET_FIELD(action->type, Type, kType_Watch);
						SET_FIELD(action->type, Operation, kOperation_None);

						handled = 1;
					}
					else if(locationParameter == kCustomLocation_Select)
					{
						SET_FIELD(action->type, LocationParameter, kCustomLocation_Comment);
						SET_FIELD(action->type, LocationType, kLocation_Custom);
						SET_FIELD(action->type, Type, 0);

						handled = 1;
					}
				}

				if(!handled)
				{
					UINT32	type = EXTRACT_FIELD(action->type, Type);

					if(type == kType_NormalOrDelay)
					{
						SET_FIELD(action->type, LocationParameter, kCustomLocation_Select);
						SET_FIELD(action->type, LocationType, kLocation_Custom);
						SET_FIELD(action->type, Type, 0);
					}
					else
					{
						SET_FIELD(action->type, Type, type - 1);
					}
				}
			}
			break;

			case kType_OneShot:
				TOGGLE_MASK_FIELD(action->type, OneShot);
				break;

			case kType_RestorePreviousValue:
				TOGGLE_MASK_FIELD(action->type, RestorePreviousValue);
				break;

			case kType_Delay:
			case kType_IgnoreDecrementBy:
			case kType_WatchSize:
			{
				UINT32	delay = (EXTRACT_FIELD(action->type, TypeParameter) - 1) & 7;

				SET_FIELD(action->type, TypeParameter, delay);
			}
			break;

			case kType_Operation:
			{
				UINT32	operation = (EXTRACT_FIELD(action->type, Operation) - 1) & 7;

				SET_FIELD(action->type, Operation, operation);
			}
			break;

			case kType_WriteMask:
			case kType_RangeMinimum:
			case kType_RangeMaximum:
			case kType_AddressIndex:
				action->extendData -= increment;
				break;

			case kType_AddSubtract:
			case kType_SetClear:
				TOGGLE_MASK_FIELD(action->type, OperationParameter);
				break;
			
			case kType_Data:
				action->data -= increment;
				action->originalDataField = action->data;
				break;

			case kType_UserSelect:
				TOGGLE_MASK_FIELD(action->type, UserSelectEnable);
				break;

			case kType_UserSelectMinimumDisp:
				TOGGLE_MASK_FIELD(action->type, UserSelectMinimumDisplay);
				break;

			case kType_UserSelectMinimum:
				TOGGLE_MASK_FIELD(action->type, UserSelectMinimum);
				break;

			case kType_UserSelectBCD:
				TOGGLE_MASK_FIELD(action->type, UserSelectBCD);
				break;

			case kType_Prefill:
				TOGGLE_MASK_FIELD(action->type, Prefill);
				break;

			case kType_CopyPrevious:
				TOGGLE_MASK_FIELD(action->type, LinkCopyPreviousValue);
				break;

			case kType_ByteLength:
			{
				UINT32	length = (EXTRACT_FIELD(action->type, BytesUsed) - 1) & 3;

				SET_FIELD(action->type, BytesUsed, length);
			}
			break;

			case kType_Endianness:
				TOGGLE_MASK_FIELD(action->type, Endianness);
				break;

			case kType_LocationType:
			{
				UINT32	locationType = EXTRACT_FIELD(action->type, LocationType);
				UINT32	locationParameter = EXTRACT_FIELD(action->type, LocationParameter);

				if(locationType == kLocation_Standard)
				{
					SET_FIELD(action->type, LocationType, kLocation_IndirectIndexed);
					SET_FIELD(action->type, LocationParameter, (locationParameter << 2) & 0x1C);
				}
				else if(locationType == kLocation_Custom)
				{
					SET_FIELD(action->type, LocationType, kLocation_HandlerMemory);
					SET_FIELD(action->type, LocationParameter, 0);
				}
				else if(locationType == kLocation_IndirectIndexed)
				{
					SET_FIELD(action->type, LocationType, kLocation_Custom);
					SET_FIELD(action->type, LocationParameter, kCustomLocation_EEPROM);
				}
				else
				{
					locationType--;

					SET_FIELD(action->type, LocationType, locationType);
				}
			}
			break;

			case kType_CPU:
			case kType_Region:
			{
				UINT32	locationParameter = EXTRACT_FIELD(action->type, LocationParameter);

				locationParameter = (locationParameter - 1) & 31;

				SET_FIELD(action->type, LocationParameter, locationParameter);
			}
			break;

			case kType_PackedCPU:
			{
				UINT32	locationParameter = EXTRACT_FIELD(action->type, LocationParameter);

				locationParameter = ((locationParameter - 0x04) & 0x1C) | (locationParameter & 0x03);

				SET_FIELD(action->type, LocationParameter, locationParameter);
			}
			break;

			case kType_PackedSize:
			{
				UINT32	locationParameter = EXTRACT_FIELD(action->type, LocationParameter);

				locationParameter = ((locationParameter - 0x01) & 0x03) | (locationParameter & 0x1C);

				SET_FIELD(action->type, LocationParameter, locationParameter);
			}
			break;

			case kType_Address:
				action->address -= increment;
				break;

			case kType_Return:
			case kType_Divider:
				break;
		}
	}

	if(UIPressedRepeatThrottle(IPT_UI_RIGHT, kHorizontalSlowKeyRepeatRate))
	{
		editActive = 0;
		dirty = 1;
		
		switch(info->fieldType)
		{
			case kType_Name:
				currentNameTemplate++;

				if((currentNameTemplate < 0) || !kCheatNameTemplates[currentNameTemplate])
				{
					currentNameTemplate = 0;
				}

				entry->name = realloc(entry->name, strlen(kCheatNameTemplates[currentNameTemplate]) + 1);
				strcpy(entry->name, kCheatNameTemplates[currentNameTemplate]);
				break;

			case kType_ActivationKey:
				entry->activationKey++;

				if(entry->activationKey < __code_key_first)
					entry->activationKey = __code_key_last;
				if(entry->activationKey > __code_key_last)
					entry->activationKey = __code_key_first;

				entry->flags |= kCheatFlag_HasActivationKey;

				logerror("++ set flag %.8X\n", entry->flags);
				break;
			
			case kType_Type:
			{
				UINT8	handled = 0;

				if(EXTRACT_FIELD(action->type, LocationType) == kLocation_Custom)
				{
					UINT32	locationParameter = EXTRACT_FIELD(action->type, LocationParameter);
					
					if(locationParameter == kCustomLocation_Comment)
					{
						SET_FIELD(action->type, LocationParameter, kCustomLocation_Select);
						SET_FIELD(action->type, LocationType, kLocation_Custom);
						SET_FIELD(action->type, Type, 0);

						handled = 1;
					}
					else if(locationParameter == kCustomLocation_Select)
					{
						SET_FIELD(action->type, LocationParameter, 0);
						SET_FIELD(action->type, LocationType, kLocation_Standard);
						SET_FIELD(action->type, Type, 0);

						handled = 1;
					}
				}

				if(!handled)
				{
					UINT32	type = EXTRACT_FIELD(action->type, Type);

					if(type == kType_Watch)
					{
						SET_FIELD(action->type, LocationParameter, kCustomLocation_Comment);
						SET_FIELD(action->type, LocationType, kLocation_Custom);
						SET_FIELD(action->type, Type, 0);
					}
					else
					{
						SET_FIELD(action->type, Type, type + 1);

						if((type + 1) == kType_Watch)
						{
							SET_FIELD(action->type, Operation, kOperation_None);
						}
					}
				}
			}
			break;

			case kType_OneShot:
				TOGGLE_MASK_FIELD(action->type, OneShot);
				break;

			case kType_RestorePreviousValue:
				TOGGLE_MASK_FIELD(action->type, RestorePreviousValue);
				break;

			case kType_Delay:
			case kType_IgnoreDecrementBy:
			case kType_WatchSize:
			{
				UINT32	delay = (EXTRACT_FIELD(action->type, TypeParameter) + 1) & 7;

				SET_FIELD(action->type, TypeParameter, delay);
			}
			break;

			case kType_Operation:
			{
				UINT32	operation = (EXTRACT_FIELD(action->type, Operation) + 1) & 7;

				SET_FIELD(action->type, Operation, operation);
			}
			break;

			case kType_WriteMask:
			case kType_RangeMinimum:
			case kType_RangeMaximum:
			case kType_AddressIndex:
				action->extendData += increment;
				break;

			case kType_AddSubtract:
			case kType_SetClear:
				TOGGLE_MASK_FIELD(action->type, OperationParameter);
				break;

			case kType_Data:
				action->data += increment;
				action->originalDataField = action->data;
				break;

			case kType_UserSelect:
				TOGGLE_MASK_FIELD(action->type, UserSelectEnable);
				break;

			case kType_UserSelectMinimumDisp:
				TOGGLE_MASK_FIELD(action->type, UserSelectMinimumDisplay);
				break;

			case kType_UserSelectMinimum:
				TOGGLE_MASK_FIELD(action->type, UserSelectMinimum);
				break;

			case kType_UserSelectBCD:
				TOGGLE_MASK_FIELD(action->type, UserSelectBCD);
				break;

			case kType_Prefill:
				TOGGLE_MASK_FIELD(action->type, Prefill);
				break;

			case kType_CopyPrevious:
				TOGGLE_MASK_FIELD(action->type, LinkCopyPreviousValue);
				break;

			case kType_ByteLength:
			{
				UINT32	length = (EXTRACT_FIELD(action->type, BytesUsed) + 1) & 3;

				SET_FIELD(action->type, BytesUsed, length);
			}
			break;

			case kType_Endianness:
				TOGGLE_MASK_FIELD(action->type, Endianness);
				break;

			case kType_LocationType:
			{
				UINT32	locationType = EXTRACT_FIELD(action->type, LocationType);
				UINT32	locationParameter = EXTRACT_FIELD(action->type, LocationParameter);

				if(locationType == kLocation_IndirectIndexed)
				{
					SET_FIELD(action->type, LocationType, kLocation_Standard);
					SET_FIELD(action->type, LocationParameter, (locationParameter >> 2) & 7);
				}
				else if(locationType == kLocation_Custom)
				{
					SET_FIELD(action->type, LocationType, kLocation_IndirectIndexed);
					SET_FIELD(action->type, LocationParameter, 0);
				}
				else if(locationType == kLocation_HandlerMemory)
				{
					SET_FIELD(action->type, LocationType, kLocation_Custom);
					SET_FIELD(action->type, LocationParameter, kCustomLocation_EEPROM);
				}
				else
				{
					locationType++;

					SET_FIELD(action->type, LocationType, locationType);
				}
			}
			break;

			case kType_CPU:
			case kType_Region:
			{
				UINT32	locationParameter = EXTRACT_FIELD(action->type, LocationParameter);

				locationParameter = (locationParameter + 1) & 31;

				SET_FIELD(action->type, LocationParameter, locationParameter);
			}
			break;

			case kType_PackedCPU:
			{
				UINT32	locationParameter = EXTRACT_FIELD(action->type, LocationParameter);

				locationParameter = ((locationParameter + 0x04) & 0x1C) | (locationParameter & 0x03);

				SET_FIELD(action->type, LocationParameter, locationParameter);
			}
			break;

			case kType_PackedSize:
			{
				UINT32	locationParameter = EXTRACT_FIELD(action->type, LocationParameter);

				locationParameter = ((locationParameter + 0x01) & 0x03) | (locationParameter & 0x1C);

				SET_FIELD(action->type, LocationParameter, locationParameter);
			}
			break;

			case kType_Address:
				action->address += increment;
				break;

			case kType_Return:
			case kType_Divider:
				break;
		}
	}

	if(UIPressedRepeatThrottle(IPT_UI_DOWN, kVerticalKeyRepeatRate))
	{
		sel++;

		if(sel >= total)
			sel = 0;

		editActive = 0;
	}

	if(UIPressedRepeatThrottle(IPT_UI_UP, kVerticalKeyRepeatRate))
	{
		sel--;

		if(sel < 0)
			sel = total - 1;

		editActive = 0;
	}

	if(UIPressedRepeatThrottle(IPT_UI_PAN_UP, kVerticalKeyRepeatRate))
	{
		sel -= Machine->uiheight / (3 * Machine->uifontheight / 2) - 1;

		if(sel < 0)
			sel = 0;

		editActive = 0;
	}

	if(UIPressedRepeatThrottle(IPT_UI_PAN_DOWN, kVerticalKeyRepeatRate))
	{
		sel += Machine->uiheight / (3 * Machine->uifontheight / 2) - 1;

		if(sel >= total)
			sel = total - 1;

		editActive = 0;
	}

	if(input_ui_pressed(IPT_UI_SELECT))
	{
		if(editActive)
		{
			editActive = 0;
		}
		else
		{
			switch(info->fieldType)
			{
				case kType_Name:
				case kType_ExtendName:
				case kType_Comment:
				case kType_ActivationKey:
				case kType_WriteMask:
				case kType_AddMaximum:
				case kType_SubtractMinimum:
				case kType_RangeMinimum:
				case kType_RangeMaximum:
				case kType_Data:
				case kType_Address:
					osd_readkey_unicode(1);
					dirty = 1;
					editActive = 1;
					break;

				case kType_Return:
					sel = -1;
					break;
			}
		}
	}

	if(editActive)
	{
		// do edit text

		dirty = 1;

		switch(info->fieldType)
		{
			case kType_Name:
				entry->name = DoDynamicEditTextField(entry->name);
				break;

			case kType_ExtendName:
				action->optionalName = DoDynamicEditTextField(action->optionalName);
				break;

			case kType_Comment:
				entry->comment = DoDynamicEditTextField(entry->comment);
				break;

			case kType_ActivationKey:
			{
				if(input_ui_pressed(IPT_UI_CANCEL))
				{
					entry->activationKey = 0;
					entry->flags &= ~kCheatFlag_HasActivationKey;

					logerror("XX clear flag %.8X\n", entry->flags);

					editActive = 0;
				}
				else
				{
					int	code = code_read_async();

					if(	(code != CODE_NONE) &&
						!input_ui_pressed(IPT_UI_SELECT))
					{
						entry->activationKey = code;
						entry->flags |= kCheatFlag_HasActivationKey;

						logerror("%d set flag %.8X\n", code, entry->flags);

						editActive = 0;
					}
				}
			}
			break;

			case kType_WriteMask:
			case kType_AddMaximum:
			case kType_SubtractMinimum:
				action->extendData = DoEditHexField(action->extendData);
				break;

			case kType_RangeMinimum:
			{
				UINT32	temp;

				temp = (action->extendData >> 8) & 0xFF;

				temp = DoEditHexField(temp) & 0xFF;

				action->extendData = (action->extendData & 0x00FF) | ((temp << 8) & 0xFF00);
			}
			break;

			case kType_RangeMaximum:
			{
				UINT32	temp;

				temp = action->extendData & 0xFF;

				temp = DoEditHexField(temp) & 0xFF;

				action->extendData = (action->extendData & 0xFF00) | (temp & 0x00FF);
			}
			break;

			case kType_Data:
				action->data = DoEditHexField(action->data);
				break;

			case kType_Address:
				action->address = DoEditHexField(action->address);
				break;
		}
	}
	else
	{
		if(input_ui_pressed(IPT_UI_SAVE_CHEAT))
		{
			SaveCheat(entry);
		}
	}

	if(input_ui_pressed(IPT_UI_CANCEL))
	{
		sel = -1;
		editActive = 0;
	}

	if(input_ui_pressed(IPT_UI_CONFIGURE))
	{
		sel = -2;
		editActive = 0;
	}

	if(	(sel == -1) ||
		(sel == -2))
	{
		editActive = 0;
		dirty = 1;
		schedule_full_refresh();
	}

	if(dirty)
	{
		UpdateCheatInfo(entry);
	}

	return sel + 1;
}

static int DoSearchMenu(struct mame_bitmap * bitmap, int selection, int startNew)
{
	enum
	{
		kMenu_Value,
		kMenu_LHS,
		kMenu_RHS,
		kMenu_Comparison,

		kMenu_Divider,

		kMenu_Size,
		kMenu_Swap,
		kMenu_Sign,

		kMenu_Divider2,

		kMenu_DoSearch,
		kMenu_Return,
		
		kMenu_Max
	};
	
	INT32			sel = selection - 1;
	static INT32	submenuChoice = 0;
	const char		* menu_item[kMenu_Max + 2] =	{ 0 };
	const char		* menu_subitem[kMenu_Max + 2] =	{ 0 };
	char			valueBuffer[20];
	SearchInfo		* search = GetCurrentSearch();
	INT32			total = 0;
	UINT32			increment = 1;

	if(search->sign && (search->value & kSearchByteSignBitTable[search->bytes]))
	{
		UINT32	tempValue;

		tempValue = ~search->value + 1;
		tempValue &= kSearchByteUnsignedMaskTable[search->bytes];
		
		sprintf(valueBuffer, "-%.*X", kSearchByteDigitsTable[search->bytes], tempValue);
	}
	else
	{
		sprintf(valueBuffer, "%.*X", kSearchByteDigitsTable[search->bytes], search->value & kSearchByteMaskTable[search->bytes]);
	}

	menu_item[total] = "Value";
	menu_subitem[total] = valueBuffer;
	total++;

	menu_item[total] = "LHS";
	menu_subitem[total] = kOperandNameTable[search->lhs];
	total++;

	menu_item[total] = "RHS";
	menu_subitem[total] = kOperandNameTable[search->rhs];
	total++;

	menu_item[total] = "Comparison";
	menu_subitem[total] = kComparisonNameTable[search->comparison];
	total++;

	menu_item[total] = "---";
	menu_subitem[total] = NULL;
	total++;
	
	menu_item[total] = "Size";
	menu_subitem[total] = kSearchByteNameTable[search->bytes];
	total++;

	menu_item[total] = "Swap";
	menu_subitem[total] = ui_getstring(search->swap ? UI_on : UI_off);
	total++;

	menu_item[total] = "Signed";
	menu_subitem[total] = ui_getstring(search->sign ? UI_on : UI_off);
	total++;

	menu_item[total] = "---";
	menu_subitem[total] = NULL;
	total++;

	menu_item[total] = "Do Search";
	menu_subitem[total] = NULL;
	total++;

	menu_item[total] = ui_getstring(UI_returntoprior);
	menu_subitem[total] = NULL;
	total++;

	menu_item[total] = NULL;
	menu_subitem[total] = NULL;

	if(sel < 0)
		sel = 0;
	if(sel >= total)
		sel = total - 1;

	ui_displaymenu(bitmap, menu_item, menu_subitem, NULL, sel, 0);

	if(AltKeyPressed())
		increment <<= 4;
	if(ControlKeyPressed())
		increment <<= 8;
	if(ShiftKeyPressed())
		increment <<= 16;

	if(UIPressedRepeatThrottle(IPT_UI_DOWN, kVerticalKeyRepeatRate))
	{
		sel++;

		if(sel >= total)
			sel = 0;
	}

	if(UIPressedRepeatThrottle(IPT_UI_UP, kVerticalKeyRepeatRate))
	{
		sel--;

		if(sel < 0)
			sel = total - 1;
	}

	if(UIPressedRepeatThrottle(IPT_UI_PAN_UP, kVerticalKeyRepeatRate))
	{
		sel -= Machine->uiheight / (3 * Machine->uifontheight / 2) - 1;

		if(sel < 0)
			sel = 0;
	}

	if(UIPressedRepeatThrottle(IPT_UI_PAN_DOWN, kVerticalKeyRepeatRate))
	{
		sel += Machine->uiheight / (3 * Machine->uifontheight / 2) - 1;

		if(sel >= total)
			sel = total - 1;
	}

	if(UIPressedRepeatThrottle(IPT_UI_LEFT, kHorizontalSlowKeyRepeatRate))
	{
		switch(sel)
		{
			case kMenu_Value:
				search->value -= increment;
				break;

			case kMenu_LHS:
				search->lhs--;

				if(search->lhs < kSearchOperand_Current)
					search->lhs = kSearchOperand_Max;
				break;

			case kMenu_RHS:
				search->rhs--;

				if(search->rhs < kSearchOperand_Current)
					search->rhs = kSearchOperand_Max;
				break;

			case kMenu_Comparison:
				search->comparison--;

				if(search->comparison < kSearchOperand_Current)
					search->comparison = kSearchOperand_Max;
				break;

			case kMenu_Size:
				search->bytes--;

				if(search->bytes < kSearchSize_8Bit)
					search->bytes = kSearchSize_Max;
				break;

			case kMenu_Swap:
				search->swap ^= 1;
				break;

			case kMenu_Sign:
				search->sign ^= 1;
				break;
		}
	}

	if(UIPressedRepeatThrottle(IPT_UI_RIGHT, kHorizontalSlowKeyRepeatRate))
	{
		switch(sel)
		{
			case kMenu_Value:
				search->value += increment;
				break;

			case kMenu_Size:
				search->bytes++;

				if(search->bytes > kSearchSize_Max)
					search->bytes = kSearchSize_8Bit;
				break;

			case kMenu_LHS:
				search->lhs++;

				if(search->lhs > kSearchOperand_Max)
					search->lhs = kSearchOperand_Current;
				break;

			case kMenu_RHS:
				search->rhs++;

				if(search->rhs > kSearchOperand_Max)
					search->rhs = kSearchOperand_Current;
				break;

			case kMenu_Comparison:
				search->comparison++;

				if(search->comparison > kSearchComparison_Max)
					search->comparison = kSearchComparison_LessThan;
				break;

			case kMenu_Swap:
				search->swap ^= 1;
				break;

			case kMenu_Sign:
				search->sign ^= 1;
				break;
		}
	}

	if(input_ui_pressed(IPT_UI_SELECT))
	{
		switch(sel)
		{
			case kMenu_Return:
				submenuChoice = 0;
				sel = -1;
				break;

			case kMenu_DoSearch:
				if(startNew)
				{
					InitializeNewSearch(search);
				}

				DoSearch(search);

				UpdateSearch(search);

				usrintf_showmessage("%d results found", search->numResults);
				break;
		}
	}

	if(input_ui_pressed(IPT_UI_CANCEL))
		sel = -1;
	if(input_ui_pressed(IPT_UI_CONFIGURE))
		sel = -2;

	if(	(sel == -1) ||
		(sel == -2))
		schedule_full_refresh();

	return sel + 1;
}

static int AddEditCheatMenu(struct mame_bitmap * bitmap, int selection)
{
	INT32			sel;
	static INT32	submenuChoice = 0;
	static INT32	submenuCheat = 0;
	const char		* menu_item[MAX_LOADEDCHEATS + 2];
	INT32			i;
	INT32			total = 0;
	CheatEntry		* entry;

	sel = selection - 1;

	if(submenuChoice)
	{
		submenuChoice = EditCheatMenu(bitmap, &cheatList[submenuCheat], submenuChoice);

		if(submenuChoice == -1)
		{
			submenuChoice = 0;
			sel = -2;
		}

		return sel + 1;
	}

	for(i = 0; i < cheatListLength; i++)
	{
		CheatEntry	* traverse = &cheatList[i];

		if(traverse->name)
			menu_item[total] = traverse->name;
		else
			menu_item[total] = "(none)";

		total++;
	}

	menu_item[total] = ui_getstring(UI_returntoprior);
	total++;

	menu_item[total] = NULL;

	if(sel < 0)
		sel = 0;
	if(sel >= total)
		sel = total - 1;

	ui_displaymenu(bitmap, menu_item, NULL, NULL, sel, 0);

	if(UIPressedRepeatThrottle(IPT_UI_DOWN, kVerticalKeyRepeatRate))
	{
		sel++;

		if(sel >= total)
			sel = 0;
	}

	if(UIPressedRepeatThrottle(IPT_UI_UP, kVerticalKeyRepeatRate))
	{
		sel--;

		if(sel < 0)
			sel = total - 1;
	}

	if(UIPressedRepeatThrottle(IPT_UI_PAN_UP, kVerticalKeyRepeatRate))
	{
		sel -= Machine->uiheight / (3 * Machine->uifontheight / 2) - 1;

		if(sel < 0)
			sel = 0;
	}

	if(UIPressedRepeatThrottle(IPT_UI_PAN_DOWN, kVerticalKeyRepeatRate))
	{
		sel += Machine->uiheight / (3 * Machine->uifontheight / 2) - 1;

		if(sel >= total)
			sel = total - 1;
	}
	
	if(sel < (total - 1))
		entry = &cheatList[sel];
	else
		entry = NULL;

	if(input_ui_pressed(IPT_UI_SAVE_CHEAT))
	{
		SaveCheat(entry);
	}

	if(input_ui_pressed(IPT_UI_ADD_CHEAT))
	{
		AddCheatBefore(sel);
	}

	if(input_ui_pressed(IPT_UI_DELETE_CHEAT))
	{
		DeleteCheatAt(sel);
	}

	if(input_ui_pressed(IPT_UI_WATCH_VALUE))
	{
		WatchCheatEntry(entry);
	}
	
	if(input_ui_pressed(IPT_UI_SELECT))
	{
		if(sel == (total - 1))
		{
			submenuChoice = 0;
			sel = -1;
		}
		else if(sel < (total - 1))
		{
			submenuCheat = sel;
			submenuChoice = 1;
		}
	}

	if(input_ui_pressed(IPT_UI_CANCEL))
		sel = -1;
	if(input_ui_pressed(IPT_UI_CONFIGURE))
		sel = -2;

	if(	(sel == -1) ||
		(sel == -2))
		schedule_full_refresh();

	return sel + 1;
}

static int ViewSearchResults(struct mame_bitmap * bitmap, int selection)
{
	enum
	{
		kMenu_Header = 0,
		kMenu_FirstResult,

		kMaxResultsPerPage = 100
	};
	
	INT32			sel;
	const char		* menu_item[kMaxResultsPerPage + 3];
	static char		buf[kMaxResultsPerPage + 3][80];
	char			header[80];
	INT32			total = 0;
	SearchInfo		* search = GetCurrentSearch();
	SearchRegion	* region;
	INT32			numPages;
	INT32			resultsPerPage;
	INT32			i;
	UINT32			traverse;
	UINT8			hadResults = 0;
	INT32			numToSkip;
	UINT32			resultsFound = 0;

	sel = selection - 1;

	if(search->currentRegionIdx >= search->regionListLength)
		search->currentRegionIdx = search->regionListLength - 1;
	if(search->currentRegionIdx < 0)
		search->currentRegionIdx = 0;

	region = &search->regionList[search->currentRegionIdx];

	resultsPerPage = Machine->uiheight / (3 * Machine->uifontheight / 2) - 4;

	if(resultsPerPage < 0)
		resultsPerPage = 1;

	numPages = (region->numResults / kSearchByteIncrementTable[search->bytes] + resultsPerPage - 1) / resultsPerPage;

	if(search->currentResultsPage >= numPages)
		search->currentResultsPage = numPages - 1;
	if(search->currentResultsPage < 0)
		search->currentResultsPage = 0;

	numToSkip = resultsPerPage * search->currentResultsPage;

	sprintf(header, "%s %d/%d", region->name, search->currentResultsPage + 1, numPages);

	menu_item[total] = header;
	total++;

	traverse = 0;

	if(region->length < kSearchByteIncrementTable[search->bytes])
	{
		// do something else
	}
	else
	{
		for(i = 0; (i < resultsPerPage) && (traverse < region->length) && (resultsFound < region->numResults);)
		{
			while(	!IsRegionOffsetValid(search, region, traverse) &&
					(traverse < region->length))
			{
				traverse += kSearchByteIncrementTable[search->bytes];
			}

			if(traverse < region->length)
			{
				if(numToSkip > 0)
				{
					numToSkip--;
				}
				else
				{
					sprintf(buf[total], "%.8X (%.*X)", region->address + traverse, kSearchByteDigitsTable[search->bytes], ReadSearchOperand(kSearchOperand_Current, search, region, region->address + traverse));
					
					menu_item[total] = buf[total];
					total++;

					i++;
				}

				traverse += kSearchByteIncrementTable[search->bytes];
				resultsFound++;
				hadResults = 1;
			}
		}
	}

	if(!hadResults)
	{
		menu_item[total] = "no results for this region";
		total++;
	}

	menu_item[total] = ui_getstring(UI_returntoprior);
	total++;

	menu_item[total] = NULL;

	if(sel < 0)
		sel = 0;
	if(sel > (total - 1))
		sel = total - 1;

	ui_displaymenu(bitmap, menu_item, NULL, NULL, sel, 0);

	if(UIPressedRepeatThrottle(IPT_UI_DOWN, kVerticalKeyRepeatRate))
	{
		sel++;

		if(sel >= total)
			sel = 0;
	}

	if(UIPressedRepeatThrottle(IPT_UI_UP, kVerticalKeyRepeatRate))
	{
		sel--;

		if(sel < 0)
			sel = total - 1;
	}

	if(UIPressedRepeatThrottle(IPT_UI_PAN_UP, kHorizontalFastKeyRepeatRate))
	{
		search->currentResultsPage--;

		if(sel < 0)
			sel = numPages - 1;
	}

	if(UIPressedRepeatThrottle(IPT_UI_PAN_DOWN, kHorizontalFastKeyRepeatRate))
	{
		search->currentResultsPage++;

		if(sel >= numPages)
			sel = 0;
	}

	if(UIPressedRepeatThrottle(IPT_UI_PAN_LEFT, kVerticalKeyRepeatRate))
	{
		search->currentRegionIdx--;

		if(sel < 0)
			sel = search->regionListLength - 1;
	}

	if(UIPressedRepeatThrottle(IPT_UI_PAN_RIGHT, kVerticalKeyRepeatRate))
	{
		search->currentRegionIdx++;

		if(sel >= search->regionListLength)
			sel = 0;
	}

	if(input_ui_pressed(IPT_UI_SELECT))
	{
		if(sel == total - 1)
		{
			sel = -1;
		}
	}

	if(input_ui_pressed(IPT_UI_CANCEL))
		sel = -1;
	if(input_ui_pressed(IPT_UI_CONFIGURE))
		sel = -2;

	if(	(sel == -1) ||
		(sel == -2))
		schedule_full_refresh();

	return sel + 1;
}

static int ChooseWatch(struct mame_bitmap * bitmap, int selection)
{
	(void)bitmap;
	(void)selection;
	
	return 0;
}

/*
static int EditWatch(struct mame_bitmap * bitmap, WatchInfo * entry, int selection)
{
	return 0;
}
*/

void DoCheat(struct mame_bitmap * bitmap)
{
	int	i;

	(void)bitmap;
	
	if(input_ui_pressed(IPT_UI_TOGGLE_CHEAT))
	{
		cheatsDisabled ^= 1;

		usrintf_showmessage_secs(1, "%s %s", ui_getstring(UI_cheats), cheatsDisabled ? ui_getstring (UI_off) : ui_getstring (UI_on));
	}

	if(cheatsDisabled)
		return;

	for(i = 0; i < cheatListLength; i++)
	{
		DoCheatEntry(&cheatList[i]);
	}
	
	/*
	{
		UINT32	data;
		
		data = cpunum_read_byte(0, 0);
		
		logerror("0:0x0 = %.8X\n", data);
	}
	*/
}

void DisplayWatches(struct mame_bitmap * bitmap)
{
	int	i;

	(void)bitmap;

	for(i = 0; i < watchListLength; i++)
	{
		WatchInfo	* info = &watchList[i];

		(void)info;
	}
}

static char * CreateStringCopy(char * buf)
{
	char	* temp = NULL;
	
	if(buf)
	{
		UINT32	length = strlen(buf) + 1;
		
		temp = malloc(length);
		
		if(temp)
		{
			memcpy(temp, buf, length);
		}
	}
	
	return temp;
}

static void ResizeCheatList(UINT32 newLength)
{
	if(newLength != cheatListLength)
	{
		if(newLength < cheatListLength)
		{
			int	i;

			for(i = newLength; i < cheatListLength; i++)
				DisposeCheat(i);
		}
		
		cheatList = realloc(cheatList, newLength * sizeof(CheatEntry));
		if(!cheatList && (newLength != 0))
		{
			logerror("ResizeCheatList: out of memory resizing cheat list\n");
			
			cheatListLength = 0;
			
			return;
		}
		
		if(newLength > cheatListLength)
		{
			memset(&cheatList[cheatListLength], 0, (newLength - cheatListLength) * sizeof(CheatEntry));
		}
		
		cheatListLength = newLength;
	}
}

static void ResizeCheatActionList(UINT32 idx, UINT32 newLength)
{
	CheatEntry	* entry;
	
	if(idx >= cheatListLength)
		return;
	
	entry = &cheatList[idx];
	
	if(newLength != entry->actionListLength)
	{
		entry->actionList = realloc(entry->actionList, newLength * sizeof(CheatAction));
		if(!entry->actionList && (newLength != 0))
		{
			logerror("ResizeCheatActionList: out of memory resizing cheat action list\n");
			
			entry->actionListLength = 0;
			
			return;
		}
		
		if(newLength > entry->actionListLength)
		{
			memset(&entry->actionList[entry->actionListLength], 0, (newLength - entry->actionListLength) * sizeof(CheatAction));
		}
		
		entry->actionListLength = newLength;
	}
}

static void AddCheatBefore(UINT32 idx)
{
	ResizeCheatList(cheatListLength + 1);
	
	if(idx < (cheatListLength - 1))
		memmove(&cheatList[idx + 1], &cheatList[idx], sizeof(CheatEntry) * (cheatListLength - 1 - idx));

	if(idx >= cheatListLength)
		idx = cheatListLength - 1;

	memset(&cheatList[idx], 0, sizeof(CheatEntry));
	
	ResizeCheatActionList(idx, 1);
}

static void DeleteCheatAt(UINT32 idx)
{
	if(idx >= cheatListLength)
		return;

	DisposeCheat(idx);
	
	if(idx < (cheatListLength - 1))
	{
		memmove(&cheatList[idx], &cheatList[idx + 1], sizeof(CheatEntry) * (cheatListLength - 1 - idx));
	}

	ResizeCheatList(cheatListLength - 1);
}

static void DisposeAction(CheatAction * action)
{
	if(action)
	{
		free(action->optionalName);
	}
}

static void DisposeCheat(UINT32 idx)
{
	if(idx < cheatListLength)
	{
		CheatEntry	* entry = &cheatList[idx];
		int			i;

		free(entry->name);
		free(entry->comment);

		for(i = 0; i < entry->actionListLength; i++)
		{
			CheatAction	* action = &entry->actionList[i];

			DisposeAction(action);
		}

		free(entry->actionList);
	}
}

static void ResizeWatchList(UINT32 newLength)
{
	if(newLength != watchListLength)
	{
		if(newLength < watchListLength)
		{
			int	i;

			for(i = newLength; i < watchListLength; i++)
				DisposeWatch(i);
		}
		
		watchList = realloc(watchList, newLength * sizeof(WatchInfo));
		if(!watchList && (newLength != 0))
		{
			logerror("ResizeWatchList: out of memory resizing watch list\n");

			watchListLength = 0;

			return;
		}

		if(newLength > watchListLength)
		{
			memset(&watchList[watchListLength], 0, (newLength - watchListLength) * sizeof(WatchInfo));
		}

		watchListLength = newLength;
	}
}

/*
static void AddWatchBefore(UINT32 idx)
{
	ResizeWatchList(watchListLength + 1);

	if(idx < (watchListLength - 1))
		memmove(&watchList[idx + 1], &watchList[idx], sizeof(WatchInfo) * (watchListLength - 1 - idx));

	if(idx >= watchListLength)
		idx = watchListLength - 1;

	memset(&watchList[idx], 0, sizeof(WatchInfo));
}
*/

/*
static void DeleteWatchAt(UINT32 idx)
{
	if(idx >= watchListLength)
		return;
	
	DisposeWatch(idx);

	if(idx < (watchListLength - 1))
	{
		memmove(&watchList[idx], &watchList[idx + 1], sizeof(WatchInfo) * (watchListLength - 1 - idx));
	}

	ResizeWatchList(watchListLength - 1);
}
*/

static void DisposeWatch(UINT32 idx)
{
	WatchInfo	* info;
	
	if(idx >= watchListLength)
		return;

	info = &watchList[idx];

	// dispose it
}

static void ResizeSearchList(UINT32 newLength)
{
	if(newLength != searchListLength)
	{
		if(newLength < searchListLength)
		{
			int	i;

			for(i = newLength; i < searchListLength; i++)
				DisposeSearch(i);
		}
		
		searchList = realloc(searchList, newLength * sizeof(SearchInfo));
		if(!searchList && (newLength != 0))
		{
			logerror("ResizeSearchList: out of memory resizing search list\n");

			searchListLength = 0;

			return;
		}

		if(newLength > searchListLength)
		{
			memset(&searchList[searchListLength], 0, (newLength - searchListLength) * sizeof(SearchInfo));
		}

		searchListLength = newLength;
	}
}

/*
static void AddSearchBefore(UINT32 idx)
{
	ResizeSearchList(searchListLength + 1);

	if(idx < (searchListLength - 1))
		memmove(&searchList[idx + 1], &searchList[idx], sizeof(SearchInfo) * (searchListLength - 1 - idx));

	if(idx >= searchListLength)
		idx = searchListLength - 1;

	memset(&searchList[idx], 0, sizeof(SearchInfo));
}
*/

/*
static void DeleteSearchAt(UINT32 idx)
{
	if(idx >= searchListLength)
		return;
	
	DisposeSearch(idx);

	if(idx < (searchListLength - 1))
	{
		memmove(&searchList[idx], &searchList[idx + 1], sizeof(SearchInfo) * (searchListLength - 1 - idx));
	}

	ResizeSearchList(searchListLength - 1);
}
*/

static void DisposeSearchRegions(SearchInfo * info)
{
	if(info->regionList)
	{
		int	i;
		
		for(i = 0; i < info->regionListLength; i++)
		{
			SearchRegion	* region = &info->regionList[i];

			free(region->first);
			free(region->last);
			free(region->status);
		}
		
		free(info->regionList);

		info->regionList = NULL;
	}

	info->regionListLength = 0;
}

static void DisposeSearch(UINT32 idx)
{
	SearchInfo	* info;

	if(idx >= searchListLength)
		return;

	info = &searchList[idx];
	
	DisposeSearchRegions(info);

	free(info->name);
	info->name = NULL;
}

static SearchInfo *	GetCurrentSearch(void)
{
	if(currentSearchIdx >= searchListLength)
		currentSearchIdx = searchListLength - 1;
	if(currentSearchIdx < 0)
		currentSearchIdx = 0;

	return &searchList[currentSearchIdx];
}

static void FillBufferFromRegion(SearchRegion * region, UINT8 * buf)
{
	UINT32	offset;
	
	// ### optimize if needed

	for(offset = 0; offset < region->length; offset++)
	{
		buf[offset] = ReadRegionData(region, offset, 1, 0);
	}
}

static UINT32 ReadRegionData(SearchRegion * region, UINT32 offset, UINT8 size, UINT8 swap)
{
	UINT32	address = region->address + offset;
	
	switch(region->targetType)
	{
		case kRegionType_CPU:
			return DoCPURead(region->targetIdx, address, size, CPUNeedsSwap(region->targetIdx) ^ swap);

		case kRegionType_Memory:
			if(region->cachedPointer)
				return DoMemoryRead(region->cachedPointer, address, size, swap, &rawCPUInfo);
			else
				return 0;
	}

	return 0;
}

static void SetSearchRegionDefaultName(SearchRegion * region)
{
	switch(region->targetType)
	{
		case kRegionType_CPU:
		{
			if(region->writeHandler)
			{
				mem_write_handler	handler = region->writeHandler->handler;
				UINT32				handlerAddress = (UINT32)handler;
				char				desc[7];

				if(	(handlerAddress >= ((UINT32)MWA_BANK1)) &&
					(handlerAddress <= ((UINT32)MWA_BANK24)))
				{
					sprintf(desc, "BANK%d", (handlerAddress - ((UINT32)MWA_BANK1)) + 1);
				}
				else
				{
					switch(handlerAddress)
					{
						case (UINT32)MWA_NOP:		strcpy(desc, "NOP");	break;
						case (UINT32)MWA_RAM:		strcpy(desc, "RAM");	break;
						case (UINT32)MWA_ROM:		strcpy(desc, "ROM");	break;
						case (UINT32)MWA_RAMROM:	strcpy(desc, "RAMROM");	break;
						default:					strcpy(desc, "CUSTOM");	break;
					}

					sprintf(region->name,	"%.*X-%.*X %.6s",
											cpuInfoList[region->targetIdx].addressCharsNeeded,
											region->address,
											cpuInfoList[region->targetIdx].addressCharsNeeded,
											region->address + region->length,
											desc);
				}
			}
			else
			{
				sprintf(region->name,	"%.*X-%.*X CPU%d",
										cpuInfoList[region->targetIdx].addressCharsNeeded,
										region->address,
										cpuInfoList[region->targetIdx].addressCharsNeeded,
										region->address + region->length,
										region->targetIdx);
			}
		}
		break;

		case kRegionType_Memory:
			sprintf(region->name, "%.8X-%.8X MEMORY", region->address, region->address + region->length + 1);
			break;

		default:
			sprintf(region->name, "UNKNOWN");
			break;
	}
}

static void BuildSearchRegions(SearchInfo * info)
{
	DisposeSearchRegions(info);

	switch(info->targetType)
	{
		case kRegionType_CPU:
		{
			if(info->targetIdx < cpu_gettotalcpu())
			{
				const struct Memory_WriteAddress	* mwa = NULL;
				SearchRegion						* traverse;
				int									count = 0;
				
				mwa = Machine->drv->cpu[info->targetIdx].memory_write;

				while(!IS_MEMPORT_END(mwa))
				{
					if(!IS_MEMPORT_MARKER(mwa))
					{
						count++;
					}

					mwa++;
				}

				info->regionList = calloc(sizeof(SearchRegion), count);
				info->regionListLength = count;
				traverse = info->regionList;

				mwa = Machine->drv->cpu[info->targetIdx].memory_write;

				while(!IS_MEMPORT_END(mwa))
				{
					if(!IS_MEMPORT_MARKER(mwa))
					{
						UINT32	length = (mwa->end - mwa->start) + 1;
						
						traverse->address = mwa->start;
						traverse->length = length;

						traverse->flags = kRegionFlag_Enabled;
						
						traverse->targetIdx = info->targetIdx;
						traverse->targetType = info->targetType;
						traverse->writeHandler = mwa;

						traverse->first = malloc(length);
						traverse->last = malloc(length);
						traverse->status = malloc(length);

						SetSearchRegionDefaultName(traverse);

						if(!traverse->first || !traverse->last || !traverse->status)
						{
							free(traverse->first);
							free(traverse->last);
							free(traverse->status);

							goto bail;
						}

						traverse++;
					}

					mwa++;
				}
			}
		}
		break;

		case kRegionType_Memory:
			break;
	}

	return;

bail:

	DisposeSearchRegions(info);

	return;
}

static int ConvertOldCode(int code, int cpu, int * data, int * extendData)
{
	enum
	{
		kCustomField_None =					0,
		kCustomField_DontApplyCPUField =	1 << 0,
		kCustomField_SetBit =				1 << 1,
		kCustomField_ClearBit =				1 << 2,
		
		kCustomField_BitMask =				kCustomField_SetBit |
											kCustomField_ClearBit,
		kCustomField_End =					0xFF
	};
	
	struct ConversionTable
	{
		int		oldCode;
		UINT32	newCode;
		UINT8	customField;
	};
	
	struct ConversionTable	kConversionTable[] =
	{
		{	0,		0x00000000,	kCustomField_None },
		{	1,		0x00000001,	kCustomField_None },
		{	2,		0x00000020,	kCustomField_None },
		{	3,		0x00000040,	kCustomField_None },
		{	4,		0x000000A0,	kCustomField_None },
		{	5,		0x00000022,	kCustomField_None },
		{	6,		0x00000042,	kCustomField_None },
		{	7,		0x000000A2,	kCustomField_None },
		{	8,		0x00000024,	kCustomField_None },
		{	9,		0x00000044,	kCustomField_None },
		{	10,		0x00000064,	kCustomField_None },
		{	11,		0x00000084,	kCustomField_None },
		{	15,		0x00000023,	kCustomField_None },
		{	16,		0x00000043,	kCustomField_None },
		{	17,		0x000000A3,	kCustomField_None },
		{	20,		0x00000000,	kCustomField_SetBit },
		{	21,		0x00000001,	kCustomField_SetBit },
		{	22,		0x00000020,	kCustomField_SetBit },
		{	23,		0x00000040,	kCustomField_SetBit },
		{	24,		0x000000A0,	kCustomField_SetBit },
		{	40,		0x00000000,	kCustomField_ClearBit },
		{	41,		0x00000001,	kCustomField_ClearBit },
		{	42,		0x00000020,	kCustomField_ClearBit },
		{	43,		0x00000040,	kCustomField_ClearBit },
		{	44,		0x000000A0,	kCustomField_ClearBit },
		{	60,		0x00000103,	kCustomField_None },
		{	61,		0x00000303,	kCustomField_None },
		{	62,		0x00000703,	kCustomField_None },
		{	63,		0x00000903,	kCustomField_None },
		{	64,		0x00000B03,	kCustomField_None },
		{	65,		0x00000F03,	kCustomField_None },
		{	70,		0x00000101,	kCustomField_None },
		{	71,		0x00000301,	kCustomField_None },
		{	72,		0x00000701,	kCustomField_None },
		{	73,		0x00000901,	kCustomField_None },
		{	74,		0x00000B01,	kCustomField_None },
		{	75,		0x00000F01,	kCustomField_None },
		{	100,	0x20000000,	kCustomField_None },
		{	101,	0x20000001,	kCustomField_None },
		{	102,	0x20000000,	kCustomField_None },
		{	103,	0x20000001,	kCustomField_None },
		{	110,	0x40000000,	kCustomField_None },
		{	111,	0x40000001,	kCustomField_None },
		{	112,	0x40000000,	kCustomField_None },
		{	113,	0x40000001,	kCustomField_None },
		{	998,	0x00000026,	kCustomField_None },
		{	999,	0x60000000,	kCustomField_DontApplyCPUField },
		{	-1,		0x00000000,	kCustomField_End }
	};
	
	struct ConversionTable	* traverse = kConversionTable;
	UINT32					newCode;
	UINT8					linkCheat = 0;
	
	// convert link cheats
	if((code >= 500) && (code <= 699))
	{
		linkCheat = 1;
		
		code -= 500;
	}
	
	// look up code
	while(traverse->oldCode >= 0)
	{
		if(code == traverse->oldCode)
		{
			goto foundCode;
		}
		
		traverse++;
	}
	
	logerror("ConvertOldCode: %d not found\n", code);
	
	// not found
	*extendData = 0;
	return 0;
	
	foundCode:
	
	newCode = traverse->newCode;
	
	// add in the CPU field
	if(!(traverse->customField & kCustomField_DontApplyCPUField))
	{
		newCode = (newCode & ~0x1F000000) | ((cpu << 24) & 0x1F000000);
	}
	
	//	set up the extend data
	if(traverse->customField & kCustomField_BitMask)
	{
		*extendData = *data;
	}
	else
	{
		*extendData = 0xFFFFFFFF;
	}
	
	if(traverse->customField & kCustomField_ClearBit)
	{
		*data = 0;
	}
	
	if(linkCheat)
	{
		SET_MASK_FIELD(newCode, LinkEnable);
	}
	
	return newCode;
}

static int MatchCommandCheatLine(char * buf)
{
	int	argumentsMatched;
	int	data;

	argumentsMatched = sscanf(buf, ":_command:%X", &data);
	
	if(argumentsMatched == 1)
	{
		switch(data & 0xFF)
		{
			case 0x00:	// disable help boxes
				break;
		}

		return 1;
	}

	return 0;
}

static void LoadCheatFile(char * fileName)
{
	void		* theFile;
	char		formatString[256];
	char		oldFormatString[256];
	char		buf[2048];
	int			recordNames = 0;
	
	logerror("LoadCheatFile: loading %s\n", fileName);
	
	theFile = osd_fopen(NULL, fileName, OSD_FILETYPE_CHEAT, 0);
	
	if(!theFile)
		return;
	
	// make the format strings
	sprintf(formatString, ":%s:%s", Machine->gamedrv->name, "%x:%x:%x:%x:%[^:\n]:%[^:\n]");
	sprintf(oldFormatString, "%s:%s", Machine->gamedrv->name, "%d:%x:%x:%d:%[^:\n]:%[^:\n]");
	
	logerror("LoadCheatFile: formatString = %s\n", formatString);
	logerror("LoadCheatFile: oldFormatString = %s\n", oldFormatString);

	while(osd_fgets(buf, 2048, theFile))
	{
		int			type;
		int			address;
		int			data;
		int			extendData;
		char		name[256];
		char		description[256];
		
		int			argumentsMatched;
		
		CheatEntry	* entry;
		CheatAction	* action;
		
		if(MatchCommandCheatLine(buf))
			continue;

		name[0] = 0;
		description[0] = 0;
		
		argumentsMatched = sscanf(buf, formatString, &type, &address, &data, &extendData, name, description);
		
		if(argumentsMatched < 5)
		{
			int	oldCPU;
			int	oldCode;

			argumentsMatched = sscanf(buf, oldFormatString, &oldCPU, &address, &data, &oldCode, name, description);
			if(argumentsMatched < 5)
			{
				continue;
			}
			else
			{
				logerror("LoadCheatFile: read old code %s", buf);
				
				// convert the old code to the new format
				type = ConvertOldCode(oldCode, oldCPU, &data, &extendData);
				
				logerror("LoadCheatFile: convert %d -> %.8X (%.8X, %.8X)\n", oldCode, type, data, extendData);
			}
		}
		else
		{
			logerror("LoadCheatFile: read new code %s", buf);
		}

		foundCheatDatabase = 1;
		
		if(TEST_FIELD(type, LinkEnable))
		{
			if(cheatListLength == 0)
			{
				logerror("LoadCheatFile: first cheat found was link cheat; bailing\n");
				
				goto bail;
			}
			
			logerror("LoadCheatFile: found link cheat, seeking to %d\n", cheatListLength - 1);

			entry = &cheatList[cheatListLength - 1];
		}
		else
		{
			// go to the next cheat
			ResizeCheatList(cheatListLength + 1);
			
			if(cheatListLength == 0)
			{
				logerror("LoadCheatFile: cheat list resize failed; bailing\n");
				
				goto bail;
			}
			
			entry = &cheatList[cheatListLength - 1];
			
			entry->name = CreateStringCopy(name);
			
			// copy the description if we got it
			if(argumentsMatched == 6)
			{
				entry->comment = CreateStringCopy(description);
			}
			
			recordNames = 0;
			
			if(	(EXTRACT_FIELD(type, LocationType) == kLocation_Custom) &&
				(EXTRACT_FIELD(type, LocationParameter) == kCustomLocation_Select))
			{
				logerror("LoadCheatFile: found select cheat, recording names\n");
				
				recordNames = 1;
			}
		}
		
		ResizeCheatActionList(cheatListLength - 1, entry->actionListLength + 1);
		
		if(entry->actionListLength == 0)
		{
			logerror("LoadCheatFile: action list resize failed; bailing\n");
			
			goto bail;
		}
		
		action = &entry->actionList[entry->actionListLength - 1];
		
		action->type = type;
		action->address = address;
		action->data = data;
		action->originalDataField = data;
		action->extendData = extendData;
		
		if(recordNames)
		{
			action->optionalName = CreateStringCopy(name);

			logerror("LoadCheatFile: recording extra name (%s)\n", action->optionalName);
		}
	}
	
	bail:
	
	osd_fclose(theFile);
	
	logerror("LoadCheatFile: done, %d cheats loaded\n", cheatListLength);
}

static void LoadCheatDatabase(void)
{
	// ### support multiple databases
	
	strcpy(mainDatabaseName, "cheat.dat");

	LoadCheatFile(mainDatabaseName);

	UpdateAllCheatInfo();
}

static void SaveCheat(CheatEntry * entry)
{
	void	* theFile;
	UINT32	i;
	char	buf[4096];
	
	if(!entry)
		return;

	theFile = osd_fopen(NULL, mainDatabaseName, OSD_FILETYPE_CHEAT, 1);

	if(!theFile)
		return;

	for(i = 0; i < entry->actionListLength; i++)
	{
		CheatAction	* action = &entry->actionList[i];
		char		* name = entry->name;
		UINT32		type = action->type;
		char		* bufTraverse = buf;

		if(i != 0)
		{
			SET_MASK_FIELD(type, LinkEnable);
			
			if(entry->flags & kCheatFlag_Select)
			{
				name = action->optionalName;
			}
		}

		bufTraverse += sprintf(bufTraverse, ":%s:%.8X:%.8X:%.8X:%.8X", Machine->gamedrv->name, type, action->address, action->originalDataField, action->extendData);

		if(name)
		{
			bufTraverse += sprintf(bufTraverse, ":%s", name);

			if((i == 0) && (entry->comment))
				bufTraverse += sprintf(bufTraverse, ":%s", entry->comment);
		}
		else
		{
			if((i == 0) && (entry->comment))
				bufTraverse += sprintf(bufTraverse, ":(none):%s", entry->comment);
		}

		logerror("SaveCheat: writing (%s)\n", bufTraverse);
		
		bufTraverse += sprintf(bufTraverse, "\n");

		osd_fwrite(theFile, buf, strlen(buf));
	}

	osd_fclose(theFile);
}

static UINT32 SearchSignExtend(SearchInfo * search, UINT32 value)
{
	if(search->sign)
	{
		if(value & kSearchByteSignBitTable[search->bytes])
		{
			value |= ~kSearchByteUnsignedMaskTable[search->bytes];
		}
	}

	return value;
}

static UINT32 ReadSearchOperand(UINT8 type, SearchInfo * search, SearchRegion * region, UINT32 address)
{
	UINT32	value = 0;
	
	switch(type)
	{
		case kSearchOperand_Current:
			value = ReadRegionData(region, address - region->address, kSearchByteIncrementTable[search->bytes], search->swap);
			break;

		case kSearchOperand_Previous:
			value = DoMemoryRead(region->last, address - region->address, kSearchByteIncrementTable[search->bytes], search->swap, NULL);
			break;

		case kSearchOperand_First:
			value = DoMemoryRead(region->first, address - region->address, kSearchByteIncrementTable[search->bytes], search->swap, NULL);
			break;

		case kSearchOperand_Value:
			value = search->value;
			break;
	}

	value = SearchSignExtend(search, value);

	return value;
}

static UINT8 DoSearchComparison(SearchInfo * search, UINT32 lhs, UINT32 rhs)
{
	if(search->sign)
	{
		INT32	slhs, srhs;

		slhs = lhs;
		srhs = rhs;

		switch(search->comparison)
		{
			case kSearchComparison_LessThan:
				return slhs < srhs;

			case kSearchComparison_GreaterThan:
				return slhs > srhs;

			case kSearchComparison_EqualTo:
				return slhs == srhs;

			case kSearchComparison_LessThanOrEqualTo:
				return slhs <= srhs;

			case kSearchComparison_GreaterThanOrEqualTo:
				return slhs >= srhs;

			case kSearchComparison_NotEqual:
				return slhs != srhs;
		}
	}
	else
	{
		switch(search->comparison)
		{
			case kSearchComparison_LessThan:
				return lhs < rhs;

			case kSearchComparison_GreaterThan:
				return lhs > rhs;

			case kSearchComparison_EqualTo:
				return lhs == rhs;

			case kSearchComparison_LessThanOrEqualTo:
				return lhs <= rhs;

			case kSearchComparison_GreaterThanOrEqualTo:
				return lhs >= rhs;

			case kSearchComparison_NotEqual:
				return lhs != rhs;
		}
	}

	return 0;
}

static UINT8 IsRegionOffsetValid(SearchInfo * search, SearchRegion * region, UINT32 offset)
{
	switch(kSearchByteIncrementTable[search->bytes])
	{
		case 1:
			return *((UINT8  *)&region->status[offset]) == 0xFF;
			break;

		case 2:
			return *((UINT16 *)&region->status[offset]) == 0xFFFF;
			break;

		case 4:
			return *((UINT32 *)&region->status[offset]) == 0xFFFFFFFF;
			break;
	}

	return 0;
}

static void InvalidateRegionOffset(SearchInfo * search, SearchRegion * region, UINT32 offset)
{
	switch(kSearchByteIncrementTable[search->bytes])
	{
		case 1:
			*((UINT8  *)&region->status[offset]) = 0;
			break;

		case 2:
			*((UINT16 *)&region->status[offset]) = 0;
			break;

		case 4:
			*((UINT32 *)&region->status[offset]) = 0;
			break;
	}
}

static void InitializeNewSearch(SearchInfo * search)
{
	int	i;

	for(i = 0; i < search->regionListLength; i++)
	{
		SearchRegion	* region = &search->regionList[i];

		memset(region->status, 0xFF, region->length);

		FillBufferFromRegion(region, region->first);
		
		memcpy(region->last, region->first, region->length);
	}
}

static void UpdateSearch(SearchInfo * search)
{
	int	i;

	for(i = 0; i < search->regionListLength; i++)
	{
		SearchRegion	* region = &search->regionList[i];

		FillBufferFromRegion(region, region->last);
	}
}

static void DoSearch(SearchInfo * search)
{
	int	i, j;

	//logerror("DoSearch\n");

	search->numResults = 0;

	for(i = 0; i < search->regionListLength; i++)
	{
		SearchRegion	* region = &search->regionList[i];
		UINT32			lastAddress = region->length - kSearchByteIncrementTable[search->bytes];
		UINT32			increment = kSearchByteIncrementTable[search->bytes];

		//logerror("	region %d\n", i);

		region->numResults = 0;

		if(region->length < kSearchByteIncrementTable[search->bytes])
		{
			// really small region, not happening
			
			continue;
		}

		for(j = 0; j < lastAddress; j += increment)
		{
			UINT32	address;
			UINT32	lhs, rhs;
			
			//logerror("		%.8X\n", j + region->address);

			address = region->address + j;
			
			if(IsRegionOffsetValid(search, region, j))
			{
				lhs = ReadSearchOperand(search->lhs, search, region, address);
				rhs = ReadSearchOperand(search->rhs, search, region, address);

				if(!DoSearchComparison(search, lhs, rhs))
				{
					InvalidateRegionOffset(search, region, j);
				}
				else
				{
					search->numResults++;
					region->numResults++;
				}
			}
		}
	}

	logerror("	done\n");
}

static UINT8 ** LookupHandlerMemory(UINT8 cpu, UINT32 address, UINT32 * outRelativeAddress)
{
	const struct Memory_WriteAddress	* mwa = Machine->drv->cpu[cpu].memory_write;
	
	while(!IS_MEMPORT_END(mwa))
	{
		if(!IS_MEMPORT_MARKER(mwa))
		{
			if(	(address >= mwa->start) &&
				(address <= mwa->end))
			{
				if(outRelativeAddress)
					*outRelativeAddress = address - mwa->start;
				
				return mwa->base;
			}
		}
		
		mwa++;
	}
	
	return NULL;
}

static UINT32 DoCPURead(UINT8 cpu, UINT32 address, UINT8 bytes, UINT8 swap)
{
	switch(bytes)
	{
		case 1:
				return	(cpunum_read_byte(cpu, address + 0) <<  0);
		
		case 2:
			if(swap)
			{
				return	(cpunum_read_byte(cpu, address + 0) <<  0) |
						(cpunum_read_byte(cpu, address + 1) <<  8);
			}
			else
			{
				return	(cpunum_read_byte(cpu, address + 0) <<  8) |
						(cpunum_read_byte(cpu, address + 1) <<  0);
			}
			break;

		case 3:
			if(swap)
			{
				return	(cpunum_read_byte(cpu, address + 0) <<  0) |
						(cpunum_read_byte(cpu, address + 1) <<  8) |
						(cpunum_read_byte(cpu, address + 2) << 16);
			}
			else
			{
				return	(cpunum_read_byte(cpu, address + 0) << 16) |
						(cpunum_read_byte(cpu, address + 1) <<  8) |
						(cpunum_read_byte(cpu, address + 2) <<  0);
			}
			break;

		case 4:
			if(swap)
			{
				return	(cpunum_read_byte(cpu, address + 0) <<  0) |
						(cpunum_read_byte(cpu, address + 1) <<  8) |
						(cpunum_read_byte(cpu, address + 2) << 16) |
						(cpunum_read_byte(cpu, address + 3) << 24);
			}
			else
			{
				return	(cpunum_read_byte(cpu, address + 0) << 24) |
						(cpunum_read_byte(cpu, address + 1) << 16) |
						(cpunum_read_byte(cpu, address + 2) <<  8) |
						(cpunum_read_byte(cpu, address + 3) <<  0);
			}
			break;
	}
	
	return 0;
}

static UINT32 DoMemoryRead(UINT8 * buf, UINT32 address, UINT8 bytes, UINT8 swap, CPUInfo * info)
{
	if(!info)
		info = &rawCPUInfo;
	
	address = SwapAddress(address, bytes, info);
	buf += address;

	switch(bytes)
	{
		case 1:
				return	(buf[0] << 0);

		case 2:
			if(swap)
			{
				return	(buf[0] << 0) |
						(buf[1] << 8);
			}
			else
			{
				return	(buf[0] << 8) |
						(buf[1] << 0);
			}
			break;

		case 3:
			if(swap)
			{
				return	(buf[0] <<  0) |
						(buf[1] <<  8) |
						(buf[2] << 16);
			}
			else
			{
				return	(buf[0] << 16) |
						(buf[1] <<  8) |
						(buf[2] <<  0);
			}
			break;

		case 4:
			if(swap)
			{
				return	(buf[0] <<  0) |
						(buf[1] <<  8) |
						(buf[2] << 16) |
						(buf[3] << 24);
			}
			else
			{
				return	(buf[0] << 24) |
						(buf[1] << 16) |
						(buf[2] <<  8) |
						(buf[3] <<  0);
			}
			break;
	}

	return 0;
}

static void DoCPUWrite(UINT32 data, UINT8 cpu, UINT32 address, UINT8 bytes, UINT8 swap)
{
	switch(bytes)
	{
		case 1:
				cpunum_write_byte(cpu, address + 0, data & 0xFF);
			break;

		case 2:
			if(swap)
			{
				cpunum_write_byte(cpu, address + 0, (data >> 0) & 0xFF);
				cpunum_write_byte(cpu, address + 1, (data >> 8) & 0xFF);
			}
			else
			{
				cpunum_write_byte(cpu, address + 0, (data >> 8) & 0xFF);
				cpunum_write_byte(cpu, address + 1, (data >> 0) & 0xFF);
			}
			break;

		case 3:
			if(swap)
			{
				cpunum_write_byte(cpu, address + 0, (data >>  0) & 0xFF);
				cpunum_write_byte(cpu, address + 1, (data >>  8) & 0xFF);
				cpunum_write_byte(cpu, address + 2, (data >> 16) & 0xFF);
			}
			else
			{
				cpunum_write_byte(cpu, address + 0, (data >> 16) & 0xFF);
				cpunum_write_byte(cpu, address + 1, (data >>  8) & 0xFF);
				cpunum_write_byte(cpu, address + 2, (data >>  0) & 0xFF);
			}
			break;

		case 4:
			if(swap)
			{
				cpunum_write_byte(cpu, address + 0, (data >>  0) & 0xFF);
				cpunum_write_byte(cpu, address + 1, (data >>  8) & 0xFF);
				cpunum_write_byte(cpu, address + 2, (data >> 16) & 0xFF);
				cpunum_write_byte(cpu, address + 3, (data >> 24) & 0xFF);
			}
			else
			{
				cpunum_write_byte(cpu, address + 0, (data >> 24) & 0xFF);
				cpunum_write_byte(cpu, address + 1, (data >> 16) & 0xFF);
				cpunum_write_byte(cpu, address + 2, (data >>  8) & 0xFF);
				cpunum_write_byte(cpu, address + 3, (data >>  0) & 0xFF);
			}
			break;

		default:
			logerror("DoCPUWrite: bad size (%d)\n", bytes);
			break;
	}
}

static void DoMemoryWrite(UINT32 data, UINT8 * buf, UINT32 address, UINT8 bytes, UINT8 swap, CPUInfo * info)
{
	if(!info)
		info = &rawCPUInfo;

	address = SwapAddress(address, bytes, info);
	buf += address;
	
	switch(bytes)
	{
		case 1:
				buf[0] = data <<  0;
			break;

		case 2:
			if(swap)
			{
				buf[0] = data <<  0;
				buf[1] = data <<  8;
			}
			else
			{
				buf[0] = data <<  8;
				buf[1] = data <<  0;
			}
			break;

		case 3:
			if(swap)
			{
				buf[0] = data <<  0;
				buf[1] = data <<  8;
				buf[2] = data << 16;
			}
			else
			{
				buf[0] = data << 16;
				buf[1] = data <<  8;
				buf[2] = data <<  0;
			}
			break;

		case 4:
			if(swap)
			{
				buf[0] = data <<  0;
				buf[1] = data <<  8;
				buf[2] = data << 16;
				buf[3] = data << 24;
			}
			else
			{
				buf[0] = data << 24;
				buf[1] = data << 16;
				buf[2] = data <<  8;
				buf[3] = data <<  0;
			}
			break;
	}
}

static UINT8 CPUNeedsSwap(UINT8 cpu)
{
	return cpuInfoList[cpu].endianness ^ LSB_FIRST;
}

static UINT8 RegionNeedsSwap(UINT8 region)
{
	CPUInfo	* temp = GetRegionCPUInfo(region);

	if(temp)
		return temp->endianness ^ LSB_FIRST;

	return 0;
}

static CPUInfo * GetCPUInfo(UINT8 cpu)
{
	return &cpuInfoList[cpu];
}

static CPUInfo * GetRegionCPUInfo(UINT8 region)
{
	if(	(region >= REGION_CPU1) &&
		(region <= REGION_CPU8))
		return &cpuInfoList[region - REGION_CPU1];

	return NULL;
}

static UINT32 SwapAddress(UINT32 address, UINT8 dataSize, CPUInfo * info)
{
	switch(dataSize)
	{
		case 1:
			switch(info->dataBits)
			{
				case 16:
					if(info->endianness == CPU_IS_BE)
						return BYTE_XOR_BE(address);
					else
						return BYTE_XOR_LE(address);

				case 32:
					if(info->endianness == CPU_IS_BE)
						return BYTE4_XOR_BE(address);
					else
						return BYTE4_XOR_LE(address);
			}
			break;

		case 2:
			switch(info->dataBits)
			{
				case 32:
					if(info->endianness == CPU_IS_BE)
						return WORD_XOR_BE(address);
					else
						return WORD_XOR_LE(address);
			}
			break;
	}

	return address;
}

static UINT32 ReadData(CheatAction * action)
{
	UINT8	parameter = EXTRACT_FIELD(action->type, LocationParameter);
	UINT8	bytes = EXTRACT_FIELD(action->type, BytesUsed) + 1;
	UINT8	swapBytes = EXTRACT_FIELD(action->type, Endianness);

	switch(EXTRACT_FIELD(action->type, LocationType))
	{
		case kLocation_Standard:
		{
			return DoCPURead(parameter, action->address, bytes, CPUNeedsSwap(parameter) ^ swapBytes);
		}
		break;
		
		case kLocation_MemoryRegion:
		{
			int		region = REGION_CPU1 + parameter;
			UINT8	* buf = memory_region(region);
			
			if(buf)
			{
				if(IsAddressInRange(action, memory_region_length(region)))
				{
					return DoMemoryRead(buf, action->address, bytes, RegionNeedsSwap(region) ^ swapBytes, GetRegionCPUInfo(region));
				}
			}
		}
		break;
		
		case kLocation_HandlerMemory:
		{
			UINT32	relativeAddress;
			UINT8	** buf;
			
			if(!action->cachedPointer)
			{
				action->cachedPointer = LookupHandlerMemory(parameter, action->address, &action->cachedOffset);
			}
			
			buf = action->cachedPointer;
			relativeAddress = action->cachedOffset;
			
			if(buf && *buf)
			{
				return DoMemoryRead(*buf, relativeAddress, bytes, CPUNeedsSwap(parameter) ^ swapBytes, GetCPUInfo(parameter));
			}
		}
		break;
		
		case kLocation_IndirectIndexed:
		{
			UINT32	address;
			INT32	offset = action->extendData;
			
			address = DoCPURead(parameter, action->address, (parameter & 0x3) + 1, CPUNeedsSwap(parameter) ^ swapBytes) + offset;
			
			return DoCPURead(parameter, address, bytes, CPUNeedsSwap(parameter) ^ swapBytes);
		}
		break;
		
		case kLocation_Custom:
		{
			switch(parameter)
			{
				case kCustomLocation_Comment:
					break;
				
				case kCustomLocation_EEPROM:
				{
					int		length;
					UINT8	* buf;
					
					buf = EEPROM_get_data_pointer(&length);
					
					if(IsAddressInRange(action, length))
						return DoMemoryRead(buf, action->address, bytes, swapBytes, &rawCPUInfo);
				}
				break;
			}
		}
		break;
		
		default:
			break;
	}
	
	return 0;
}

static void WriteData(CheatAction * action, UINT32 data)
{
	UINT8	parameter = EXTRACT_FIELD(action->type, LocationParameter);
	UINT8	bytes = EXTRACT_FIELD(action->type, BytesUsed) + 1;
	UINT8	swapBytes = EXTRACT_FIELD(action->type, Endianness);
	
	switch(EXTRACT_FIELD(action->type, LocationType))
	{
		case kLocation_Standard:
		{
			DoCPUWrite(data, parameter, action->address, bytes, CPUNeedsSwap(parameter) ^ swapBytes);
		}
		break;
		
		case kLocation_MemoryRegion:
		{
			int		region = REGION_CPU1 + parameter;
			UINT8	* buf = memory_region(region);
			
			if(buf)
			{
				if(IsAddressInRange(action, memory_region_length(region)))
				{
					DoMemoryWrite(data, buf, action->address, bytes, RegionNeedsSwap(region) ^ swapBytes, GetRegionCPUInfo(region));
				}
			}
		}
		break;
		
		case kLocation_HandlerMemory:
		{
			UINT32	relativeAddress;
			UINT8	** buf;
			
			if(!action->cachedPointer)
			{
				action->cachedPointer = LookupHandlerMemory(parameter, action->address, &action->cachedOffset);
			}
			
			buf = action->cachedPointer;
			relativeAddress = action->cachedOffset;
			
			if(buf && *buf)
			{
				DoMemoryWrite(data, *buf, relativeAddress, bytes, CPUNeedsSwap(parameter) ^ swapBytes, GetCPUInfo(parameter));
			}
		}
		break;
		
		case kLocation_IndirectIndexed:
		{
			UINT32	address;
			INT32	offset = action->extendData;
			UINT8	cpu = (parameter >> 2) & 0x7;
			UINT8	addressBytes = (parameter & 0x3) + 1;
			
			address = DoCPURead(cpu, action->address, addressBytes, CPUNeedsSwap(cpu) ^ swapBytes) + offset;
			
			DoCPUWrite(data, cpu, address, bytes, CPUNeedsSwap(cpu) ^ swapBytes);
		}
		break;
		
		case kLocation_Custom:
		{
			switch(parameter)
			{
				case kCustomLocation_Comment:
					break;
				
				case kCustomLocation_EEPROM:
				{
					int		length;
					UINT8	* buf;
					
					buf = EEPROM_get_data_pointer(&length);
					
					if(IsAddressInRange(action, length))
						DoMemoryWrite(data, buf, action->address, bytes, swapBytes, &rawCPUInfo);
				}
				break;
			}
		}
		break;
		
		default:
			break;
	}
}

static void WatchCheatEntry(CheatEntry * entry)
{
	UINT32	i;
	
	if(!entry)
		return;

	for(i = 0; i < entry->actionListLength; i++)
	{
		AddActionWatch(&entry->actionList[i], 0);
	}
}

static void AddActionWatch(CheatAction * action, UINT8 associate)
{
	(void)action;
	(void)associate;
	
	// ###
}

static void ResetAction(CheatAction * action)
{
	action->frameTimer = 0;
	action->lastValue = ReadData(action);
	action->flags &= ~kActionFlag_StateMask;
}

static void ActivateCheat(CheatEntry * entry)
{
	int	i;
	
	for(i = 0; i < entry->actionListLength; i++)
	{
		CheatAction	* action = &entry->actionList[i];
		
		ResetAction(action);
		
		if(EXTRACT_FIELD(action->type, Type) == kType_Watch)
			AddActionWatch(action, 1);
	}
	
	entry->flags |= kCheatFlag_Active;
}

static void DeactivateCheat(CheatEntry * entry)
{
	entry->flags &= ~kCheatFlag_StateMask;
}

static void DoCheatOperation(CheatAction * action)
{
	UINT8	operation =	EXTRACT_FIELD(action->type, Operation) |
						(EXTRACT_FIELD(action->type, OperationExtend) << 2);
	
	switch(operation)
	{
		case kOperation_WriteMask:
		{
			UINT32	temp;
			
			if(action->flags & kActionFlag_IgnoreMask)
			{
				WriteData(action, action->data);
			}
			else
			{
				temp = ReadData(action);
				
				temp = (action->data & action->extendData) | (temp & ~action->extendData);
				
				WriteData(action, temp);
			}
		}
		break;
		
		case kOperation_AddSubtract:
		{
			UINT32	temp;
			
			if(action->flags & kActionFlag_IgnoreMask)
				return;

			temp = ReadData(action);
			
			// OperationParameter field stores add/subtract
			if(TEST_FIELD(action->type, OperationParameter))
			{
				// subtract
				
				temp -= action->data;
				
				if(temp < action->extendData)
					temp = action->extendData;
			}
			else
			{
				// add
				
				temp += action->data;
				
				if(temp > action->extendData)
					temp = action->extendData;
			}
			
			WriteData(action, temp);
		}
		break;
		
		case kOperation_ForceRange:
		{
			UINT32	temp;
			
			if(action->flags & kActionFlag_IgnoreMask)
				return;

			temp = ReadData(action);
			
			if(	(temp < ((action->extendData >> 8) & 0xFF)) ||
				(temp > ((action->extendData >> 0) & 0xFF)))
			{
				temp = action->data;
				
				WriteData(action, temp);
			}
		}
		break;
		
		case kOperation_SetOrClearBits:
		{
			UINT32	temp;
			
			temp = ReadData(action);
			
			if(TEST_FIELD(action->type, OperationParameter))
			{
				// clear
				
				temp &= ~action->data;
			}
			else
			{
				// set
				
				temp |= action->data;
			}
			
			WriteData(action, temp);
		}
		break;
		
		case kOperation_None:
			break;
		
		default:
			break;
	}
}

static void DoCheatAction(CheatAction * action)
{
	UINT8	parameter = EXTRACT_FIELD(action->type, TypeParameter);
	
	if(action->flags & kActionFlag_OperationDone)
		return;
	
	switch(EXTRACT_FIELD(action->type, Type))
	{
		case kType_NormalOrDelay:
		{
			if(action->frameTimer >= (parameter * Machine->drv->frames_per_second))
			{
				action->frameTimer = 0;
				
				DoCheatOperation(action);
				
				if(TEST_FIELD(action->type, OneShot))
				{
					action->flags |= kActionFlag_OperationDone;
				}
			}
			else
			{
				action->frameTimer++;
			}
		}
		break;
		
		case kType_WaitForModification:
		{
			if(action->flags & kActionFlag_WasModified)
			{
				if(action->frameTimer <= 0)
				{
					DoCheatOperation(action);
					
					action->flags &= ~kActionFlag_WasModified;
					
					if(TEST_FIELD(action->type, OneShot))
					{
						action->flags |= kActionFlag_OperationDone;
					}
				}
				else
				{
					action->frameTimer--;
				}
				
				action->lastValue = ReadData(action);
			}
			else
			{
				UINT8	currentValue = ReadData(action);
				
				if(currentValue != action->lastValue)
				{
					action->frameTimer = parameter * Machine->drv->frames_per_second;
					
					action->flags |= kActionFlag_WasModified;
				}
				
				action->lastValue = currentValue;
			}
		}
		break;
		
		case kType_IgnoreIfDecrementing:
		{
			UINT8	currentValue = ReadData(action);
			
			if(currentValue != (action->lastValue - parameter))
			{
				DoCheatOperation(action);
				
				if(TEST_FIELD(action->type, OneShot))
				{
					action->flags |= kActionFlag_OperationDone;
				}
			}
			
			action->lastValue = currentValue;
		}
		break;
		
		case kType_Watch:
		default:
			break;
	}
}

static void DoCheatEntry(CheatEntry * entry)
{
	int	i;

	// special handling for select cheats
	if(entry->flags & kCheatFlag_Select)
	{
		// if a subcheat is selected and it's a legal index, handle it
		if(entry->selection && (entry->selection < entry->actionListLength))
		{
			DoCheatAction(&entry->actionList[entry->selection]);
		}
	}
	else
	{
		if(	(entry->flags & kCheatFlag_HasActivationKey) &&
			!(entry->flags & kCheatFlag_UserSelect))
		{
			if(code_pressed(entry->activationKey))
			{
				if(!(entry->flags & kCheatFlag_ActivationKeyPressed))
				{
					if(entry->flags & kCheatFlag_OneShot)
					{
						ActivateCheat(entry);
					}
					else
					{
						if(entry->flags & kCheatFlag_Active)
						{
							DeactivateCheat(entry);
						}
						else
						{
							ActivateCheat(entry);
						}
					}

					entry->flags |= kCheatFlag_ActivationKeyPressed;
				}
			}
			else
			{
				entry->flags &= ~kCheatFlag_ActivationKeyPressed;
			}
		}
		
		if(!(entry->flags & kCheatFlag_Active))
			return;
		
		// update all actions
		for(i = 0; i < entry->actionListLength; i++)
		{
			DoCheatAction(&entry->actionList[i]);
		}
		
		// if all actions are done, deactivate the cheat
		{
			UINT8	done = 1;
			
			for(i = 0; (i < entry->actionListLength) && done; i++)
				if(!(entry->actionList[i].flags & kActionFlag_OperationDone))
					done = 0;
			
			if(done)
			{
				DeactivateCheat(entry);
			}
		}
	}
}

static void UpdateAllCheatInfo(void)
{
	int	i;

	for(i = 0; i < cheatListLength; i++)
	{
		UpdateCheatInfo(&cheatList[i]);
	}
}

static void UpdateCheatInfo(CheatEntry * entry)
{
	int		isOneShot =	1;
	int		isNull =	1;
	int		flags =		0;
	int		i;

	flags |= entry->flags & kCheatFlag_PersistantMask;
	
	if(	(EXTRACT_FIELD(entry->actionList[0].type, LocationType) == kLocation_Custom) &&
		(EXTRACT_FIELD(entry->actionList[0].type, LocationParameter) == kCustomLocation_Select))
		flags |= kCheatFlag_Select;
	
	for(i = 0; i < entry->actionListLength; i++)
	{
		CheatAction	* action =		&entry->actionList[i];
		int			isActionNull =	0;
		
		if(	(EXTRACT_FIELD(action->type, LocationType) == kLocation_Custom) &&
			(EXTRACT_FIELD(action->type, LocationParameter) == kCustomLocation_Comment))
		{
			isActionNull = 1;
		}
		else
		{
			isNull = 0;
		}
		
		if(!TEST_FIELD(action->type, OneShot))
			isOneShot = 0;
		
		if(TEST_FIELD(action->type, UserSelectEnable))
			flags |= kCheatFlag_UserSelect;

		if(EXTRACT_FIELD(action->type, LocationType) == kLocation_IndirectIndexed)
			action->flags |= kActionFlag_IgnoreMask;

		action->flags &= kActionFlag_InfoMask;
	}
	
	if(isOneShot)
		flags |= kCheatFlag_OneShot;
	if(isNull)
		flags |= kCheatFlag_Null;
	
	entry->flags = (flags & kCheatFlag_InfoMask) | (entry->flags & ~kCheatFlag_InfoMask);
}

static int IsAddressInRange(CheatAction * action, UINT32 length)
{
	UINT8	bytes = EXTRACT_FIELD(action->type, BytesUsed) + 1;
	
	return ((action->address + bytes) <= length);
}

static void BuildCPUInfoList(void)
{
	int	i;

	memset(cpuInfoList, 0, sizeof(CPUInfo) * MAX_CPU);

	logerror("BuildCPUInfoList: cpu_gettotalcpu = %d\n", cpu_gettotalcpu());

	for(i = 0; i < cpu_gettotalcpu(); i++)
	{
		int	type = Machine->drv->cpu[i].cpu_type & ~CPU_FLAGS_MASK;
		
		cpuInfoList[i].type = type;
		cpuInfoList[i].dataBits = cputype_databus_width(type);
		cpuInfoList[i].addressBits = cputype_address_bits(type);

		cpuInfoList[i].addressCharsNeeded = cpuInfoList[i].addressBits >> 2;
		if(cpuInfoList[i].addressBits & 0x3)
			cpuInfoList[i].addressCharsNeeded++;

		cpuInfoList[i].endianness = cputype_endianess(type);

		logerror("CPU%d: %d %d %d %d %d\n",	i,
											cpuInfoList[i].type,
											cpuInfoList[i].dataBits,
											cpuInfoList[i].addressBits,
											cpuInfoList[i].addressCharsNeeded,
											cpuInfoList[i].endianness);
	}
}

#else

int pika_pika_pika = 0;

#endif
